from pylab import *
# Full Linear Airy (\tau=\nu_1=\nu_2=0)

g=9.81

class AIRY:
    
    def __init__(self,tau=0.0,nu1=0.0,nu2=0.0):
        self.tau=tau
        self.nu1=nu1
        self.nu2=nu2
        print 'airy class'
  #Dispersion relation components#
    #$\omega^2 + i(\nu_1 + \nu_2)k^2\omega - \nu_1\nu_2 k^4 -
    #-(1 + \tau k2)gHk^2 tanh(kH)/kH = 0$
    def ik2wnu1(self,x):
        return x/x #to avoid complaints on not valid y values 

    def ik2wnu2(self,x):
        return x/x

    def nu1nu2k4(self,x):
        return x/x

    def gHk2(self,x):
        return tanh(x)/x

    def gHk2tau(self,x):
        return tanh(x)/x

  #Dispersion Characteristics          
    def phase(self,x):
        return sqrt((1.+self.tau*x**2)*tanh(x)/x)

    def group(self,x):
        return self.phase(x)*(1+2*x/sinh(2*x))/2.

    def shoal(self,x):
        return 2*x*(sinh(2*x)+x*(1-cosh(2*x)))/((2*x+sinh(2*x))**2)

  
print '''
************************
Airy module loaded
************************'''
