from pylab import *
from matplotlib.widgets import Slider



#linear wave shoaling gradient

#6-order,z=0 model
h0=1
h=1

def k(x):
    return x

#generic phase velocity
def phase(a,b,c,d,x):
    return sqrt((1.-a*x**2+b*x**4)/(1-c*x**2+d*x**4))

#generic group velocity
def group(a,b,c,d,x):
    return sqrt((1.-a*x**2+b*x**4)/(1-c*x**2+d*x**4))+\
           ((4.*b*x**4-2.*a*x**2)/(1-c*x**2+d*x**4)-\
            (4.*d*x**4-2.*c*x**2)*(1.-a*x**2+b*x**4)/\
            (1-c*x**2+d*x**4)**2)/\
            (2.*sqrt((1.-a*x**2+b*x**4)/(1-c*x**2+d*x**4)))


class AIRY:
    def __init__(self):
        print 'airy class'

    def phase(self,x):
        return sqrt(tanh(x)/x)

    def group(self,x):
        return self.phase(x)*(1+2*x/sinh(2*x))/2.

    def shoal(self,x):
        return 2*x*(sinh(2*x)+x*(1-cosh(2*x)))/((2*x+sinh(2*x))**2)


class LPT2Z0:
    def __init__(self):
        print 'airy class'
    
    def phase(self,x):
        return 1./(1.+1./3.*x**2)



class ZCT:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x):
        return sqrt((1.+x**2/15.)/(1.+2.*x**2/5))

    def group(self,x):
        a=-1./15.
        b=0.
        c=-2./5.
        d=0.
        return group(a,b,c,d,x)
    

    def c1(self,x):
        return 2.*(1.+2./15.*h**2*k(x)**2+2./75.*h**4*k(x)**4)
    
    def c2(self,x):
        return (1.+2./5.*h**2*k(x)**2+2./15.*h**4*k(x)**4)
    
    def c3(self,x):
        return (1.-2./5.*h**2*k(x)**2+2./25.*h**4*k(x)**4) 
    
    def c4(self,x):
        return (1.+1./5.*h**2*k(x)**2+2./75.*h**4*k(x)**4)/\
               (2.*(1.+1./15.*h**2*k(x)**2+1./75.*h**4*k(x)**4))
    
    def shoal(self,x):
        return (self.c3(x)-self.c2(x)*self.c4(x))/self.c1(x)



class Z06:
    def __init__(self):
        print('z06 class')

    def phase(self,x):
        a=1./3.
        b=2./15.
        c=0.
        d=0.
        return phase(a,b,c,d,x)

    def group(self,x):
        a=1./3.
        b=2./15.
        c=0.
        d=0.
        return group(a,b,c,d,x)


    def c1(self,x):
        return 4./5.*(h0**5/h)*(k(x)**4)-4./3.*h**2*k(x)**2 +2.
    
    def c2(self,x):
        return 2.*(h0**5/h)*(k(x)**4)-2.*(k(x)**2)*h**2+1.
    
    def c3(self,x):
        return 1.-2.*k(x)**2*h**2 
    
    def c4(self,x):
        return (-15.*h**2*(k(x)**2)+15.)/(12.*(h0**5/h)*k(x)**4-20.*h**2*k(x)**2+30.) 
    
    def shoal(self,x): 
        return (self.c3(x)-self.c2(x)*self.c4(x))/self.c1(x)


class Z04:
    def __init__(self):
        print '''z04 class'''

    def phase(self,x):
        a=1./3.
        b=0.
        c=0.
        d=-2./15.
        return phase(a,b,c,d,x)
   
    def group(self,x):
        a=1./3.
        b=0.
        c=0.
        d=-2./15.
        return group(a,b,c,d,x)

        ##variation over my2 model
        ##def my3(x):
        ##return sqrt(1.-1./3.*x**2+2./15.*x**4-2./45.*x**6)
     
    def c1(self,x):
        return 2.-4./3.*h**2*k(x)**2
    
    def c2(self,x):
        return (10.*(h**4)*((k(x))**4)-27.*h**2*k(x)**2+27.)\
               /(3.*(k(x))**2*h**2-9.)
    
    def c3(self,x):
        return (2.*(h**4)*(k(x)**4)-3.*h**2*k(x)**2+3.)/(h**2*k(x)**2-3.) 
    
    def c4(self,x):
        return (2.*(h**2)*(h0**4)*k(x)**6-2.*h0**4*k(x)**4-\
                15.*h**2*k(x)**2+15.)\
               /(4.*h0**4*k(x)**4-20.*h**2*(k(x))**2+30.) 
    
    def shoal(self,x):
        return (self.c3(x)-self.c2(x)*self.c4(x))/self.c1(x)
   

class ZA6:
    def __init__(self):
        print 'za6 class'

    def phase(self,al,x):
        a=al**2/2.-al+1./3.
        b=5.*al**4/24.+7.*al**2/6.-5.*al**3/6.\
           -2.*al/3.+2./15.
        c=al**2/2.-al
        d=5.*al**4/24.+al**2-5.*al**3/6.-al/3.
        return phase(a,b,c,d,x)

    def group(self,al,x):
        a=al**2/2.-al+1./3.
        b=5.*al**4/24.+7.*al**2/6.-5.*al**3/6.\
           -2.*al/3.+2./15.
        c=al**2/2.-al
        d=5.*al**4/24.+al**2-5.*al**3/6.-al/3.
        return group(a,b,c,d,x)

    def D1(self,alp):
        return (5./24.*alp**4-5./6.*alp**3\
        +7./6.*alp**2-2./3.*alp+2./15.)
    
    def D2(self,alp):
        return (5.*alp**4/24.-5.*alp**3/6.+alp**2-alp/3.)
    
    def D3(self,alp):
        return alp**2/2.-alp
   
    def D5(self,alp):
        return (-3.*alp**2+6.*alp-2.)

    def D10(self,alp):
        return (-7.*alp**2+12.*alp-4.)

    def D11(self,alp):
        return (30.*alp**2-72.*alp+24.)

    def D12(self,alp):
        return (6.*alp**2-24.*alp+8.)
  
    def c1(self,x,alp):
        return 2./3.*h**2*k(x)**2*self.D5(alp)+\
               6.*h0**5/h*k(x)**4*self.D1(alp)+2.
    
    def c2(self,x,alp):
        return -(5.*h**4*k(x)**4*self.D5(alp)**2+\
                 (81.*h*h0**5*k(x)**6*self.D1(alp)\
                  +27.*h**2*k(x)**2)*self.D5(alp)+\
                 378.*h0**10/h**2*k(x)**8*self.D1(alp)**2\
                 +144.*h0**5/h*k(x)**4*self.D1(alp)+54.)/\
                 (3.*h**2*k(x)**2*self.D5(alp)+18.*h0**5/h*k(x)**4*self.D1(alp)+18.)
    
    def c3(self,x,alp):
        return -((h**4*k(x)**4*self.D10(alp)+\
                  36.*h*h0**5*k(x)**6*self.D1(alp)+10.*h**2*k(x)**2)\
                 *self.D5(alp)\
                 +h**2*k(x)**2*self.D12(alp)+\
                 h*h0**5*k(x)**6*self.D1(alp)*self.D11(alp)\
                 +60.*h0**5/h*k(x)**4*self.D1(alp)+12.)/\
                 (2.*h**2*k(x)**2*self.D5(alp)+\
                  12.*h0**5/h*k(x)**4*self.D1(alp)+12.)
    
    def c4(self,x,alp):
        return ((8.*h**4*k(x)**4*self.D3(alp)\
                 -24.*h**2*h0**4*k(x)**6*self.D2(alp)\
                -24.*h**2*k(x)**2)*self.D5(alp)\
                -96.*h*h0**5*k(x)**6*self.D1(alp)*self.D3(alp)\
                -24.*h**2*k(x)**2*self.D3(alp)\
                -48.*h0**4*k(x)**4*self.D2(alp)-48.)\
                /((16.*h**4*k(x)**4*self.D3(alp)\
                   -32.*h**2*k(x)**2)*self.D5(alp)+\
                  self.D1(alp)*(192.*h*h0**5*k(x)**6*self.D3(alp)\
                                -96.*h0**9/h*k(x)**8*self.D2(alp)\
                                -288.*h0**5/h*k(x)**4)\
                  +96.*h0**4*k(x)**4*self.D2(alp)-96.)


    
    def c5(self,x,alp): 
        return (self.c3(x,alp)-self.c2(x,alp)*self.c4(x,alp))/self.c1(x,alp)

    #just to have the same order used in phase and group vel
    def shoal(self,alp,x):
        return self.c5(x,alp)
    

class ZA4:
    def __init__(self):
        print 'za4 class'

    def phase(self,al,x):
        a=al**2/2.-al+1./3.
        b=0.
        c=al**2/2.-al
        d=-al**2/6.+al/3.-2./15.
        return phase(a,b,c,d,x)

    def group(self,al,x):
        a=al**2/2.-al+1./3.
        b=0.
        c=al**2/2.-al
        d=-al**2/6.+al/3.-2./15.
        return group(a,b,c,d,x)


    def D3(self,alp):
        return (alp**2/2.-alp)
    

    def D5(self,alp):
        return (-3.*alp**2+6.*alp-2.)
    
    def D10(self,alp):
        return (-7.*alp**2+12.*alp-4.)

    def D12(self,alp):
        return (6.*alp**2-24.*alp+8.)

    def D13(self,alp):
        return (5.*alp**2-10.*alp+4.)
  
   
    def c1(self,x,alp):
        return 2./3.*h**2*k(x)**2*self.D5(alp)+2.
    
    def c2(self,x,alp):
        return -(5.*h**4*k(x)**4*self.D5(alp)**2+\
                 27.*h**2*k(x)**2*self.D5(alp)+54.)/\
                 (3.*h**2*k(x)**2*self.D5(alp)+18.)
    
    def c3(self,x,alp):
        return -((h**4*k(x)**4*self.D10(alp)+\
                  +10.*h**2*k(x)**2)*self.D5(alp)\
                 +h**2*k(x)**2*self.D12(alp)+12.)/\
                 (2.*h**2*k(x)**2*self.D5(alp)+12.)
    
    def c4(self,x,alp):
        return ((10.*h**4*k(x)**4*self.D3(alp)+h**2*h0**4*k(x)**6*self.D13(alp)\
                -30.*h**2*k(x)**2)*self.D5(alp)-60.*h**2*k(x)**2*self.D3(alp)\
                +2.*h0**4*k(x)**4*self.D13(alp)-60.)/\
                ((20.*h**4*k(x)**4*self.D3(alp)-40.*h**2*k(x)**2)*self.D5(alp)-4.*h0**4*k(x)**4*self.D13(alp)\
                 -120.)
    
    def c5(self,x,alp): 
        return (self.c3(x,alp)-self.c2(x,alp)*self.c4(x,alp))/self.c1(x,alp)

    #just to have the same order used in phase and group vel
    def shoal(self,alp,x):
        return self.c5(x,alp)
   

class ZA0A14:
    def __init__(self):
        print 'za4 class'
        
    def phase(self,alp0,x):
        a=alp0**2/2.-alp0+1./3.
        b=0.
        c=alp0**2/2.-alp0
        d=-alp0**2/6.+alp0/3.-2./15.
        return phase(a,b,c,d,x)
    
    def group(self,alp0,x):
        a=alp0**2/2.-alp0+1./3.
        b=0.
        c=alp0**2/2.-alp0
        d=-alp0**2/6.+alp0/3.-2./15.
        return group(a,b,c,d,x)
   

    def D2(self,alp0,alp1):
        return (-alp0**2./6.+alp0/3.-2./15.)

    def D3(self,alp0,alp1):
        return (3.*alp1**2-6.*alp0*alp1+3.*alp0**2)

    def D4(self,alp0,alp1):
        return (-6.*alp1**2+(6.*alp0+6.)*alp1-6.*alp0)

    def D5(self,alp0,alp1):
        return (3.*alp1**2-6.*alp1+2.)
    
    def D6(self,alp0,alp1):
        return (9.*alp1**2-12.*alp1+4.)

    def D7(self,alp0,alp1):
        return (21.*alp1**2-36.*alp1+12.)


    def D8(self,alp0,alp1):
        return (-54.*alp1**2+(54.*alp0+48.)*alp1-48.*alp0)

    def D9(self,alp0,alp1):
        return (-30.*alp1**2+(30.*alp0+24.)*alp1-24.*alp0)

    def D10(self,alp0,alp1):
        return (-3.*alp1**2+12.*alp1-4.)

    def D11(self,alp0,alp1):
        return (6.*alp0*alp1-6.*alp1**2)

    def D12(self,alp0,alp1):
        return (18.*alp1**2-72.*alp1+24.)

    def D13(self,alp0,alp1):
        return (alp1**2-2.*alp1)

    def D14(self,alp0,alp1):
        return (alp0**2-2.*alp0)

    def D15(self,alp0,alp1):
        return ((2.-2*alp0)*alp1+2.*alp0)

    def c1(self,x,alp0,alp1):
        return -2./3.*h**2*k(x)**2*self.D5(alp0,alp1)\
               -2./3.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2./3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               +2

    def NUMC2(self,x,alp0,alp1):
        return 5.*h**4*k(x)**4*self.D5(alp0,alp1)**2+\
               (10.*h**3*h0*k(x)**4*self.D4(alp0,alp1)+\
                10.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                -27.*h**2*k(x)**2)*self.D5(alp0,alp1)\
                +5.*h**2*h0**2*k(x)**4*self.D4(alp0,alp1)**2+\
                (10.*h*h0**3*k(x)**4*self.D3(alp0,alp1)-27*h*h0*k(x)**2)\
                *self.D4(alp0,alp1)\
                +5.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
                -27.*h0**2*k(x)**2*self.D3(alp0,alp1)\
                +54.

    def DENC2(self,x,alp0,alp1):
        return 3.*h**2*k(x)**2*self.D5(alp0,alp1)+\
               3.*h*h0*k(x)**2*self.D4(alp0,alp1)+\
               3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -18.
               
    def c2(self,x,alp0,alp1):
        return self.NUMC2(x,alp0,alp1)/self.DENC2(x,alp0,alp1)

    
    def NUMC3(self,x,alp0,alp1):
        return h**2*h0**2*k(x)**4*self.D4(alp0,alp1)*self.D9(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D5(alp0,alp1)*self.D8(alp0,alp1)\
               +h**4*k(x)**4*self.D5(alp0,alp1)*self.D7(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D4(alp0,alp1)*self.D6(alp0,alp1)\
               +(11.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                 -30.*h**2*k(x)**2)*self.D5(alp0,alp1)\
               +(7.*h*h0**3*k(x)**4*self.D3(alp0,alp1)-\
                 18.*h*h0*k(x)**2)*self.D4(alp0,alp1)\
               +3.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
               +(h*h0**3*k(x)**4*self.D11(alp0,alp1)+\
                 h**2*h0**2*k(x)**4*self.D10(alp0,alp1)-\
                 24.*h0**2*k(x)**2)*self.D3(alp0,alp1)\
               +h**2*k(x)**2*self.D12(alp0,alp1)\
               -6.*h*h0*k(x)**2*self.D11(alp0,alp1)\
               +36.
                 
                 
        
    def DENC3(self,x,alp0,alp1):
        return 6.*h**2*k(x)**2*self.D5(alp0,alp1)\
               +6.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               +6.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -36.
    
    def c3(self,x,alp0,alp1):
        return self.NUMC3(x,alp0,alp1)/self.DENC3(x,alp0,alp1)
    
    def NUMC4(self,x,alp0,alp1):
        return -6.*h**2*h0**4*k(x)**6*self.D2(alp0,alp1)*self.D5(alp0,alp1)\
               -3.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1)\
               +3.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1)\
               +3.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1)\
               -2.*h**3*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1)\
               -6.*h**2*k(x)**2*self.D5(alp0,alp1)-4.*h*h0**5*k(x)**6*self.D2(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +h**2*h0**2*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h**2*h0*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -4.*h*h0*k(x)**2*self.D4(alp0,alp1)-2.*h0**6*k(x)**6*self.D2(alp0,alp1)*self.D3(alp0,alp1)\
               -h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +h*h0**3*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)+h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -2.*h0**2*k(x)**2*self.D3(alp0,alp1)+12.*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +6.*h0*(h-h0)*k(x)**2*self.D15(alp0,alp1)-6.*h*h0*k(x)**2*self.D15(alp0,alp1)\
               -6.*h0**2*k(x)**2*self.D14(alp0,alp1)-6.*(h-h0)**2*k(x)**2*self.D13(alp0,alp1)\
               +24.*h*(h-h0)*k(x)**2*self.D13(alp0,alp1)+12.
                 
        
    def DENC4(self,x,alp0,alp1):
        return -2.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1)\
               +2.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1)\
               +2.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1)\
               -8.*h**2*k(x)**2*self.D5(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -8.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2.*h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -8.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -24.*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +24.
               
    
    def c4(self,x,alp0,alp1):
        return self.NUMC4(x,alp0,alp1)/self.DENC4(x,alp0,alp1)

    def c5(self,x,alp0,alp1): 
        return (self.c3(x,alp0,alp1)-self.c2(x,alp0,alp1)*self.c4(x,alp0,alp1))\
               /self.c1(x,alp0,alp1)

    #just to have the same order used in phase and group vel
    def shoal(self,alp0,alp1,x):
        return self.c5(x,alp0,alp1)


class ZBETA4:
    def __init__(self):
        print 'za4 class shoaling9'

      
    def phase(self,alp0,x,beta):
        a=alp0**2/2.-alp0+1./3.
        b=0.
        c=alp0**2/2.-alp0
        d=beta*(-alp0**2/6.+alp0/3.-2./15.)
        return phase(a,b,c,d,x)
    
    def group(self,alp0,x,beta):
        a=alp0**2/2.-alp0+1./3.
        b=0.
        c=alp0**2/2.-alp0
        d=beta*(-alp0**2/6.+alp0/3.-2./15.)
        return group(a,b,c,d,x)
  


    def D2(self,alp0,alp1):
        return (-alp0**2./6.+alp0/3.-2./15.)

    def D3(self,alp0,alp1):
        return (3.*alp1**2-6.*alp0*alp1+3.*alp0**2)

    def D4(self,alp0,alp1):
        return (-6.*alp1**2+(6.*alp0+6.)*alp1-6.*alp0)

    def D5(self,alp0,alp1):
        return (3.*alp1**2-6.*alp1+2.)
    
    def D6(self,alp0,alp1):
        return (9.*alp1**2-12.*alp1+4.)

    def D7(self,alp0,alp1):
        return (21.*alp1**2-36.*alp1+12.)


    def D8(self,alp0,alp1):
        return (-54.*alp1**2+(54.*alp0+48.)*alp1-48.*alp0)

    def D9(self,alp0,alp1):
        return (-30.*alp1**2+(30.*alp0+24.)*alp1-24.*alp0)

    def D10(self,alp0,alp1):
        return (-3.*alp1**2+12.*alp1-4.)

    def D11(self,alp0,alp1):
        return (6.*alp0*alp1-6.*alp1**2)

    def D12(self,alp0,alp1):
        return (18.*alp1**2-72.*alp1+24.)

    def D13(self,alp0,alp1):
        return (alp1**2-2.*alp1)

    def D14(self,alp0,alp1):
        return (alp0**2-2.*alp0)

    def D15(self,alp0,alp1):
        return ((2.-2*alp0)*alp1+2.*alp0)

   
    def c1(self,x,alp0,alp1):
        return -2./3.*h**2*k(x)**2*self.D5(alp0,alp1)\
               -2./3.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2./3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               +2.

    def NUMC2(self,x,alp0,alp1):
        return 5.*h**4*k(x)**4*self.D5(alp0,alp1)**2+\
               (10.*h**3*h0*k(x)**4*self.D4(alp0,alp1)+\
                10.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                -27.*h**2*k(x)**2)*self.D5(alp0,alp1)\
                +5.*h**2*h0**2*k(x)**4*self.D4(alp0,alp1)**2+\
                (10.*h*h0**3*k(x)**4*self.D3(alp0,alp1)\
                 -27*h*h0*k(x)**2)\
                *self.D4(alp0,alp1)\
                +5.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
                -27.*h0**2*k(x)**2*self.D3(alp0,alp1)\
                +54.

    def DENC2(self,x,alp0,alp1):
        return 3.*h**2*k(x)**2*self.D5(alp0,alp1)+\
               3.*h*h0*k(x)**2*self.D4(alp0,alp1)+\
               3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -18.
               
    def c2(self,x,alp0,alp1):
        return self.NUMC2(x,alp0,alp1)/self.DENC2(x,alp0,alp1)

    
    def NUMC3(self,x,alp0,alp1):
        return h**2*h0**2*k(x)**4*self.D4(alp0,alp1)*self.D9(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D5(alp0,alp1)*self.D8(alp0,alp1)\
               +h**4*k(x)**4*self.D5(alp0,alp1)*self.D7(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D4(alp0,alp1)*self.D6(alp0,alp1)\
               +(11.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                 -30.*h**2*k(x)**2)*self.D5(alp0,alp1)\
               +(7.*h*h0**3*k(x)**4*self.D3(alp0,alp1)\
                 -18.*h*h0*k(x)**2)*self.D4(alp0,alp1)\
               +3.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
               +(h*h0**3*k(x)**4*self.D11(alp0,alp1)+\
                 h**2*h0**2*k(x)**4*self.D10(alp0,alp1)\
                 -24.*h0**2*k(x)**2)*self.D3(alp0,alp1)\
               -6.*h*h0*k(x)**2*self.D11(alp0,alp1)\
               +h**2*k(x)**2*self.D12(alp0,alp1)\
               +36.
                 
                 
        
    def DENC3(self,x,alp0,alp1):
        return 6.*h**2*k(x)**2*self.D5(alp0,alp1)\
               +6.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               +6.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -36.
    
    def c3(self,x,alp0,alp1):
        return self.NUMC3(x,alp0,alp1)/self.DENC3(x,alp0,alp1)
    
    def NUMC4(self,x,alp0,alp1,beta):
        return -6.*beta*h**2*h0**4*k(x)**6*self.D2(alp0,alp1)*self.D5(alp0,alp1)\
               -3.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1)\
               +3.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1)\
               +3.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1)\
               -2.*h**3*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1)\
               -6.*h**2*k(x)**2*self.D5(alp0,alp1)\
               -4.*beta*h*h0**5*k(x)**6*self.D2(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +h**2*h0**2*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h**2*h0*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -4.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2.*beta*h0**6*k(x)**6*self.D2(alp0,alp1)*self.D3(alp0,alp1)\
               -h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +h*h0**3*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)+h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -2.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               +12.*beta*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +6.*h0*(h-h0)*k(x)**2*self.D15(alp0,alp1)-6.*h*h0*k(x)**2*self.D15(alp0,alp1)\
               -6.*h0**2*k(x)**2*self.D14(alp0,alp1)-6.*(h-h0)**2*k(x)**2*self.D13(alp0,alp1)\
               +24.*h*(h-h0)*k(x)**2*self.D13(alp0,alp1)+12.
                 
        
    def DENC4(self,x,alp0,alp1,beta):
        return -2.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1)\
               +2.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1)\
               +2.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1)\
               -8.*h**2*k(x)**2*self.D5(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -8.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2.*h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -8.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -24.*beta*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +24.
               
    
    def c4(self,x,alp0,alp1,beta):
        return self.NUMC4(x,alp0,alp1,beta)/self.DENC4(x,alp0,alp1,beta)

    def c5(self,x,alp0,alp1,beta): 
        return (self.c3(x,alp0,alp1)-self.c2(x,alp0,alp1)*self.c4(x,alp0,alp1,beta))\
               /self.c1(x,alp0,alp1)

    #just to have the same order used in phase and group vel
    def shoal(self,alp0,alp1,beta,x):
        return self.c5(x,alp0,alp1,beta)





class Z___BETA__4:
    def __init__(self):
        print 'za4 class shoaling?'

    def D2(self,alp0,alp1):
        return (-alp0**2./6.+alp0/3.-2./15.)

    def D3(self,alp0,alp1):
        return (3.*alp1**2-6.*alp0*alp1+3.*alp0**2)

    def D4(self,alp0,alp1):
        return (-6.*alp1**2+(6.*alp0+6.)*alp1-6.*alp0)

    def D5(self,alp0,alp1,beta):
        return (3.*alp1**2-6.*alp1+2.*beta)
    
    def D6(self,alp0,alp1,beta):
        return (9.*alp1**2-12.*alp1+4.*beta)

    def D7(self,alp0,alp1,beta):
        return (21.*alp1**2-36.*alp1+12.*beta)


    def D8(self,alp0,alp1):
        return (-54.*alp1**2+(54.*alp0+48.)*alp1-48.*alp0)

    def D9(self,alp0,alp1):
        return (-30.*alp1**2+(30.*alp0+24.)*alp1-24.*alp0)

    def D10(self,alp0,alp1,beta):
        return (-3.*alp1**2+12.*alp1-4.*beta)

    def D11(self,alp0,alp1):
        return (6.*alp0*alp1-6.*alp1**2)

    def D12(self,alp0,alp1,beta):
        return (18.*alp1**2-72.*alp1+24.*beta)

    def D13(self,alp0,alp1):
        return (alp1**2-2.*alp1)

    def D14(self,alp0,alp1):
        return (alp0**2-2.*alp0)

    def D15(self,alp0,alp1):
        return ((2.-2*alp0)*alp1+2.*alp0)

   
    def c1(self,x,alp0,alp1,beta):
        return -2./3.*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               -2./3.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2./3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               +2.*beta

    def NUMC2(self,x,alp0,alp1,beta):
        return 5.*h**4*k(x)**4*self.D5(alp0,alp1,beta)**2+\
               (10.*h**3*h0*k(x)**4*self.D4(alp0,alp1)+\
                10.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                -27.*beta*h**2*k(x)**2)*self.D5(alp0,alp1,beta)\
                +5.*h**2*h0**2*k(x)**4*self.D4(alp0,alp1)**2+\
                (10.*h*h0**3*k(x)**4*self.D3(alp0,alp1)\
                 -27*beta*h*h0*k(x)**2)\
                *self.D4(alp0,alp1)\
                +5.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
                -27.*beta*h0**2*k(x)**2*self.D3(alp0,alp1)\
                +54.*beta**2

    def DENC2(self,x,alp0,alp1,beta):
        return 3.*h**2*k(x)**2*self.D5(alp0,alp1,beta)+\
               3.*h*h0*k(x)**2*self.D4(alp0,alp1)+\
               3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -18.*beta
               
    def c2(self,x,alp0,alp1,beta):
        return self.NUMC2(x,alp0,alp1,beta)/self.DENC2(x,alp0,alp1,beta)

    
    def NUMC3(self,x,alp0,alp1,beta):
        return h**2*h0**2*k(x)**4*self.D4(alp0,alp1)*self.D9(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D5(alp0,alp1,beta)*self.D8(alp0,alp1)\
               +h**4*k(x)**4*self.D5(alp0,alp1,beta)*self.D7(alp0,alp1,beta)\
               +h**3*h0*k(x)**4*self.D4(alp0,alp1)*self.D6(alp0,alp1,beta)\
               +(11.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                 -30.*beta*h**2*k(x)**2)*self.D5(alp0,alp1,beta)\
               +(7.*h*h0**3*k(x)**4*self.D3(alp0,alp1)\
                 -18.*beta*h*h0*k(x)**2)*self.D4(alp0,alp1)\
               +3.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
               +(h*h0**3*k(x)**4*self.D11(alp0,alp1)+\
                 h**2*h0**2*k(x)**4*self.D10(alp0,alp1,beta)\
                 -24.*beta*h0**2*k(x)**2)*self.D3(alp0,alp1)\
               -6.*beta*h*h0*k(x)**2*self.D11(alp0,alp1)\
               +beta*h**2*k(x)**2*self.D12(alp0,alp1,beta)\
               +36.*beta**2
                 
                 
        
    def DENC3(self,x,alp0,alp1,beta):
        return 6.*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               +6.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               +6.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -36.*beta
    
    def c3(self,x,alp0,alp1,beta):
        return self.NUMC3(x,alp0,alp1,beta)/self.DENC3(x,alp0,alp1,beta)
    
    def NUMC4(self,x,alp0,alp1,beta):
        return -6.*h**2*h0**4*k(x)**6*self.D2(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -3.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +h**3*h0*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +3.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +3.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -2.*h**3*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -6.*beta*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               -4.*h*h0**5*k(x)**6*self.D2(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +h**2*h0**2*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h**2*h0*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -4.*beta*h*h0*k(x)**2*self.D4(alp0,alp1)-2.*h0**6*k(x)**6*self.D2(alp0,alp1)*self.D3(alp0,alp1)\
               -h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +h*h0**3*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)+h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -2.*beta*h0**2*k(x)**2*self.D3(alp0,alp1)+12.*beta*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +6.*beta*h0*(h-h0)*k(x)**2*self.D15(alp0,alp1)-6.*beta*h*h0*k(x)**2*self.D15(alp0,alp1)\
               -6.*beta*h0**2*k(x)**2*self.D14(alp0,alp1)-6.*beta*(h-h0)**2*k(x)**2*self.D13(alp0,alp1)\
               +24.*beta*h*(h-h0)*k(x)**2*self.D13(alp0,alp1)+12.*beta**2
                 
        
    def DENC4(self,x,alp0,alp1,beta):
        return -2.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +2.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +2.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -8.*beta*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -8.*beta*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2.*h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -8.*beta*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -24.*beta*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +24.*beta**2
               
    
    def c4(self,x,alp0,alp1,beta):
        return self.NUMC4(x,alp0,alp1,beta)/self.DENC4(x,alp0,alp1,beta)

    def c5(self,x,alp0,alp1,beta): 
        return (self.c3(x,alp0,alp1,beta)-self.c2(x,alp0,alp1,beta)*self.c4(x,alp0,alp1,beta))\
               /self.c1(x,alp0,alp1,beta)

    #just to have the same order used in phase and group vel
    def shoal(self,alp0,alp1,beta,x):
        return self.c5(x,alp0,alp1,beta)


class _Z_BETA_4:
    def __init__(self):
        print 'za4 class shoaling6'

    def D2(self,alp0,alp1):
        return (-alp0**2./6.+alp0/3.-2./15.)

    def D3(self,alp0,alp1):
        return (3.*alp1**2-6.*alp0*alp1+3.*alp0**2)

    def D4(self,alp0,alp1):
        return (-6.*alp1**2+(6.*alp0+6.)*alp1-6.*alp0)

    def D5(self,alp0,alp1,beta):
        return (3.*alp1**2-6.*alp1+2.*beta)
    
    def D6(self,alp0,alp1,beta):
        return (9.*alp1**2-12.*alp1+4.*beta)

    def D7(self,alp0,alp1,beta):
        return (21.*alp1**2-36.*alp1+12.*beta)


    def D8(self,alp0,alp1):
        return (-54.*alp1**2+(54.*alp0+48.)*alp1-48.*alp0)

    def D9(self,alp0,alp1):
        return (-30.*alp1**2+(30.*alp0+24.)*alp1-24.*alp0)

    def D10(self,alp0,alp1,beta):
        return (-3.*alp1**2+12.*alp1-4.*beta)

    def D11(self,alp0,alp1):
        return (6.*alp0*alp1-6.*alp1**2)

    def D12(self,alp0,alp1,beta):
        return (18.*alp1**2-72.*alp1+24.*beta)

    def D13(self,alp0,alp1):
        return (alp1**2-2.*alp1)

    def D14(self,alp0,alp1):
        return (alp0**2-2.*alp0)

    def D15(self,alp0,alp1):
        return ((2.-2*alp0)*alp1+2.*alp0)

    def D16(self,beta):
        return (1.-beta)

    def c1(self,x,alp0,alp1,beta):
        return -2./3.*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               -2./3.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2./3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -4./3.*h0**3/h*k(x)**2*self.D16(beta)\
               +2.

    def NUMC2(self,x,alp0,alp1,beta):
        return 5.*h**4*k(x)**4*self.D5(alp0,alp1,beta)**2+\
               (10.*h**3*h0*k(x)**4*self.D4(alp0,alp1)+\
                10.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                +20.*h*h0**3*k(x)**4*self.D16(beta)\
                -27.*h**2*k(x)**2)*self.D5(alp0,alp1,beta)\
                +5.*h**2*h0**2*k(x)**4*self.D4(alp0,alp1)**2+\
                (10.*h*h0**3*k(x)**4*self.D3(alp0,alp1)\
                 +20.*h0**4*k(x)**4*self.D16(beta)\
                 -27*h*h0*k(x)**2)\
                *self.D4(alp0,alp1)\
                +5.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
                +(20.*h0**5/h*k(x)**4*self.D16(beta)\
                -27.*h0**2*k(x)**2)*self.D3(alp0,alp1)\
                +20.*h0**6/h**2*k(x)**4*self.D16(beta)**2\
                -54.*h0**3/h*k(x)**2*self.D16(beta)\
                +54.

    def DENC2(self,x,alp0,alp1,beta):
        return 3.*h**2*k(x)**2*self.D5(alp0,alp1,beta)+\
               3.*h*h0*k(x)**2*self.D4(alp0,alp1)+\
               3.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               +6.*h0**3/h*k(x)**2*self.D16(beta)\
               -18.
               
    def c2(self,x,alp0,alp1,beta):
        return self.NUMC2(x,alp0,alp1,beta)/self.DENC2(x,alp0,alp1,beta)

    
    def NUMC3(self,x,alp0,alp1,beta):
        return h**2*h0**2*k(x)**4*self.D4(alp0,alp1)*self.D9(alp0,alp1)\
               +h**3*h0*k(x)**4*self.D5(alp0,alp1,beta)*self.D8(alp0,alp1)\
               +h**4*k(x)**4*self.D5(alp0,alp1,beta)*self.D7(alp0,alp1,beta)\
               +h**3*h0*k(x)**4*self.D4(alp0,alp1)*self.D6(alp0,alp1,beta)\
               +(11.*h**2*h0**2*k(x)**4*self.D3(alp0,alp1)\
                 +24.*h*h0**3*k(x)**4*self.D16(beta)\
                 -30.*h**2*k(x)**2)*self.D5(alp0,alp1,beta)\
               +(7.*h*h0**3*k(x)**4*self.D3(alp0,alp1)\
                 +16.*h0**4*k(x)**4*self.D16(beta)\
                 -18.*h*h0*k(x)**2)*self.D4(alp0,alp1)\
               +3.*h0**4*k(x)**4*self.D3(alp0,alp1)**2\
               +(6.*h0**5/h*k(x)**4*self.D16(beta)\
                 +h*h0**3*k(x)**4*self.D11(alp0,alp1)+\
                 h**2*h0**2*k(x)**4*self.D10(alp0,alp1,beta)\
                 -24.*h0**2*k(x)**2)*self.D3(alp0,alp1)\
               -48.*h0**3/h*k(x)**2*self.D16(beta)\
               -6.*h*h0*k(x)**2*self.D11(alp0,alp1)\
               +h**2*k(x)**2*self.D12(alp0,alp1,beta)\
               +36.
                 
                 
        
    def DENC3(self,x,alp0,alp1,beta):
        return 6.*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               +6.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               +6.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               +12.*h0**3/h*k(x)**2*self.D16(beta)\
               -36.
    
    def c3(self,x,alp0,alp1,beta):
        return self.NUMC3(x,alp0,alp1,beta)/self.DENC3(x,alp0,alp1,beta)
    
    def NUMC4(self,x,alp0,alp1,beta):
        return -6.*h**2*h0**4*k(x)**6*self.D2(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -3.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +h**3*h0*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +3.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +3.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -2.*h**3*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -6.*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               -4.*h*h0**5*k(x)**6*self.D2(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +h**2*h0**2*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -2.*h**2*h0*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -4.*h*h0*k(x)**2*self.D4(alp0,alp1)-2.*h0**6*k(x)**6*self.D2(alp0,alp1)*self.D3(alp0,alp1)\
               -h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +h*h0**3*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)+h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**4*k(x)**4*self.D15(alp0,alp1)*self.D16(beta)\
               -4.*h0**3*(h-h0)*k(x)**4*self.D13(alp0,alp1)*self.D16(beta)\
               -2.*h0**2*k(x)**2*self.D3(alp0,alp1)+12.*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +6.*h0*(h-h0)*k(x)**2*self.D15(alp0,alp1)-6.*h*h0*k(x)**2*self.D15(alp0,alp1)\
               -6.*h0**2*k(x)**2*self.D14(alp0,alp1)-6.*(h-h0)**2*k(x)**2*self.D13(alp0,alp1)\
               +24.*h*(h-h0)*k(x)**2*self.D13(alp0,alp1)+12.
                 
        
    def DENC4(self,x,alp0,alp1,beta):
        return -2.*h**2*h0*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +2.*h**2*h0**2*k(x)**4*self.D14(alp0,alp1)*self.D5(alp0,alp1,beta)\
               +2.*h**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D5(alp0,alp1,beta)\
               -8.*h**2*k(x)**2*self.D5(alp0,alp1,beta)\
               -2.*h*h0**2*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0**3*k(x)**4*self.D14(alp0,alp1)*self.D4(alp0,alp1)\
               +2.*h*h0*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D4(alp0,alp1)\
               -8.*h*h0*k(x)**2*self.D4(alp0,alp1)\
               -2.*h0**3*(h-h0)*k(x)**4*self.D15(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**4*k(x)**4*self.D14(alp0,alp1)*self.D3(alp0,alp1)\
               +2.*h0**2*(h-h0)**2*k(x)**4*self.D13(alp0,alp1)*self.D3(alp0,alp1)\
               -8.*h0**2*k(x)**2*self.D3(alp0,alp1)\
               -24.*h0**4*k(x)**4*self.D2(alp0,alp1)\
               +4.*h0**5/h*k(x)**4*self.D14(alp0,alp1)*self.D16(beta)\
               +4.*h0**3*(h-h0)**2/h*self.D13(alp0,alp1)*self.D16(beta)\
               +8.*h0**4*(h-h0)/h*(alp0*alp1-alp0-alp1)*k(x)**4*self.D16(beta)\
               -16.*h0**3/h*k(x)**2*self.D16(beta)\
               +24.
               
    
    def c4(self,x,alp0,alp1,beta):
        return self.NUMC4(x,alp0,alp1,beta)/self.DENC4(x,alp0,alp1,beta)

    def c5(self,x,alp0,alp1,beta): 
        return (self.c3(x,alp0,alp1,beta)-self.c2(x,alp0,alp1,beta)*self.c4(x,alp0,alp1,beta))\
               /self.c1(x,alp0,alp1,beta)

    #just to have the same order used in phase and group vel
    def shoal(self,alp0,alp1,beta,x):
        return self.c5(x,alp0,alp1,beta)

        
class NWG1:
    def __init__(self):
        print 'Nwogu1 class'

    def ap(self):
        return -0.39

    def be(self):
        return -0.0566667

    def phase(self,x):
        return sqrt((1.+0.0566667*x**2)/(1.+0.39*x**2))

    def group(self,x):
        a=-0.05666667
        b=0.
        c=-0.39
        d=0.
        return group(a,b,c,d,x)

    def T1(self,x):
        return -2.*x**2*(1.-self.ap()*self.be()*x**4)/\
               ((1.-self.ap()*x**2)*(1.-self.be()*x**2)*\
                (3.*(1.-self.ap()*x**2)*(1.-self.be()*x**2)-x**2))

    def T2(self,x):
        return 2.*(1+self.be()*(self.ap()*x*2-2.)*x)/\
               (1.-self.ap()*x**2)*(1.-self.be()*x**2)

    def shoal(self,x):
        return 0.5*(1+(self.T1(x)-1)/self.T2(x))
    


class NWG2:
    def __init__(self):
        print 'Nwogu2 class'
        
    def  ap(self):
        return -0.3855

    def  be(self):
        return -0.05216667

    def phase(self,x):
        return sqrt((1.+0.05216667*x**2)/(1.+0.3855*x**2))

    def group(self,x):
        a=-0.05216667
        b=0.
        c=-0.3855
        d=0.
        return group(a,b,c,d,x)

    def T1(self,x):
        return -2.*x**2*(1.-self.ap()*self.be()*x**4)/\
               ((1.-self.ap()*x**2)*(1.-self.be()*x**2)*\
                (3.*(1.-self.ap()*x**2)*(1.-self.be()*x**2)-x**2))

    def T2(self,x):
        return 2.*(1+self.be()*(self.ap()*x*2-2.)*x)/\
               (1.-self.ap()*x**2)*(1.-self.be()*x**2)

    def shoal(self,x):
        return 0.5*(1+(self.T1(x)-1.)/self.T2(x))



class DUDI:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x):
        return sqrt((1.+1.*x**2/6.)/(1.+x**2/2.))



g=9.8
class AIRY_D:
    def __init__(self):
        print 'airy class'

    def phase(self,x,nu):
        fx=[]
        for i in range(len(x)):
            if (tanh(x[i])/x[i]-(nu*x[i]/2.)**2/g)<0:
                fx.insert(i,0.0)
            else:
                fx.insert(i,sqrt(tanh(x[i])/x[i]-(nu*x[i]/2.)**2/g))
        return  fx
            
class AIRY_T:
    def __init__(self):
        print 'airy class'

    def phase(self,x,t):
        return sqrt((1+t*x**2)*tanh(x)/x)

class ZCT_D:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x,nu):
        fx=[]
        for i in range(len(x)):
            if ((1.+x[i]**2/15.)/(1.+2.*x[i]**2/5.)-(nu*x[i]/2.)**2/g)<0:
                fx.insert(i,0.0)
            else:
                fx.insert(i,sqrt((1.+x[i]**2/15.)/(1.+2.*x[i]**2/5.)-(nu*x[i]/2.)**2/g))
        return  fx

class ZCT_DK:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x,nu):
        fx=[]
        for i in range(len(x)):
            if ((1.+x[i]**2/15.)/(1.+2.*x[i]**2/5.)-((nu*x[i]/(2.*(1.+2.*x[i]**2/5.)))**2)/g)<0:
                fx.insert(i,0.0)
            else:
                fx.insert(i,sqrt((1.+x[i]**2/15.)/(1.+2.*x[i]**2/5.)-(nu*x[i]/(2.*(1.+2.*x[i]**2/5.))**2)/g))
        return  fx


class ZCT_DT:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x,nu,T):
        fx=[]
        for i in range(len(x)):
            if ((1.+(1.+T/g)*x[i]**2/15.)/(1.+2.*x[i]**2/5.)-(nu*x[i]/2.)**2/g)<0:
                fx.insert(i,0.0)
            else:
                fx.insert(i,sqrt((1.+x[i]**2/15.)/(1.+2.*x[i]**2/5.)-(nu*x[i]/2.)**2/g))
        return  fx

         
class ZCT_T:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x,t):
        return sqrt((1.+(1.+t)*x**2/15.)/(1.+2.*x**2/5.))
    
class DUDI_D:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x,nu):
        return sqrt((1.+1.*x**2/6.)/(1.+x**2/2.)-(nu*x/(2.+x**2))**2/g)
   





# z06=Z06()
# z04=Z04()    
# x0=arange(0.0,6.0,0.01)
# # x1=arange(0.0,40.0,0.01)

# #  #subplots_adjust(left=0.25, bottom=0.25)


# # # #subplot(111)

# xlabel('kH')
# ylabel('Shoaling coefficient')

# plot(x0,airyshoaling(x0),label='airy')
# plot(x0,z06.c5(x0),label='z=0,6-order')
# plot(x0,z04.c5(x0),label='z=0,4-order')
# legend()
# show()
