from pylab import *

#LPT Type-I 4^{th}-order model 


# Ti coefficients
def T(Ca,Cb,x):
    return 1.-Ca*x**2+Cb*x**4

class LPTt14o:
 
    def __init__(self,alpha=0.):
        self.alpha=alpha
        self.C1=self.alpha**2/2.-self.alpha+1./3.
        self.C2=0.0
        self.C3=0.0
        self.C4=0.0
        self.C5=0.0
        self.C6=self.alpha**2/2.-self.alpha
        self.C7=-self.alpha**2/6.+self.alpha/3.-2./15.
        self.C8=self.alpha**2/2.-self.alpha
        self.C9=0.
        print 'LPT T-I 4-order class'
        print 'alpha='+str(self.alpha)
        print 'C1='+str(self.C1)
        print 'C2='+str(self.C2)
        print 'C3='+str(self.C3)
        print 'C4='+str(self.C4)
        print 'C5='+str(self.C5)
        print 'C6='+str(self.C6)
        print 'C7='+str(self.C7)
        print 'C8='+str(self.C8)
        print 'C9='+str(self.C9)+'\n'
       
    def T1(self,x):
        return T(self.C1,self.C2,x)

    def T2(self,x):
        return T(self.C3,self.C4,x)

    def T3(self,x):
        return T(self.C6,self.C7,x)

    def T4(self,x):
        return T(self.C8,0.,x)

    def T5(self,x):
        return T(self.C6+self.C5,self.C6*self.C5+self.C7,x)

    def T6(self,x):
        return T(self.C5+self.C8,self.C5*self.C8,x)

    def T7(self,x):
        return T(0.,self.C9,x)

 ##Dispersion relation components#
 ##$\omega^2 + i(\nu_1 T_4/T_3 + \nu_2 T_5/T_2T_3)k^2\omega
 ##- \nu_1\nu_2 k^4 T_6/T_2T_3 -
 ##-(T_7 + \tau k2)gHk^2 T_1/T_2T_3 = 0$

    def ik2wnu1(self,x):
        return self.T5(x)/(self.T2(x)*self.T3(x))

    def ik2wnu2(self,x):
        return self.T4(x)/self.T3(x)

    def nu1nu2k4(self,x):
        return self.T6(x)/(self.T2(x)*self.T3(x))

    def gHk2(self,x):
        return self.T1(x)*self.T7(x)/(self.T2(x)*self.T3(x))
      
    def gHk2tau(self,x):
        return self.T1(x)/(self.T2(x)*self.T3(x))

   
    def phase(self,x):
        return sqrt(T(self.C1,self.C2,x)/\
                    (T(self.C3,self.C4,x)*T(self.C6,self.C7,x)))

print '''
*****************************
LPT T-I 4-order module loaded 
*****************************
'''
print '''
testclass with default initialization values:
'''
testclass=LPTt14o(1.-1./7.*sqrt(7.))  
