#!/usr/bin/env python

from pylab import *
from matplotlib.widgets import Slider

#My classes
from airy import *
from zct import *
from lptt16o import *
from lptt14o import *
from lptt26o import *
from lptt24o import *

#ranges 
x0=arange(0.0,20.,0.1)

################## PLOT COMMANDS #######################

airy=AIRY()
zct=LPTt16o(1-1./5.*sqrt(5.))
lpt1=LPTt16o(0.0)
lpt2=LPTt16o(1.0)
lpt3=LPTt14o(1.0)
lpt4=LPTt16o(1-1./7.*sqrt(7.))
lpt5=LPTt14o(1-1./7.*sqrt(7.))

beta_1=0.000017
beta_2=-0.0001
beta_11=0.00001
beta_21=-0.0002
alpha_1=1.-1./6.*sqrt(6.)
alpha_2=1.-1./5.*sqrt(5.)
alpha_3=1.-1./7.*sqrt(7.)
print 'ALPHA**********'
print alpha_1
print alpha_2
print alpha_3
print '***************'
lpt6=LPTt24o(alpha_1,beta_1,beta_2)
lpt7=LPTt24o(alpha_1,beta_11,beta_21)
lpt8=LPTt24o(alpha_2,beta_1,beta_2)
lpt9=LPTt24o(alpha_2,beta_11,beta_21)
lpt10=LPTt24o(alpha_3,beta_11,beta_21)
figure(1)
subplots_adjust(left=0.10,right=0.90,top=0.90, bottom=0.1)
subplot(111)


xlabel('psfragx')
ylabel('psfragy')

#plot(x0,airy.phase(x0),label='Airy')
#plot(x0,zct.phase(x0),label='$\\alpha=1-\\frac{1}{5}\\sqrt{5}$')
#plot(x0,lpt1.phase(x0),label='$\\alpha=0$')
#plot(x0,lpt2.phase(x0),label='$6^{th}$-order $\\alpha=1$')
#plot(x0,lpt3.phase(x0),label='$4^{th}$-order $\\alpha=1$')
#plot(x0,lpt4.phase(x0),label='$6^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7}$')
#plot(x0,lpt5.phase(x0),label='$4^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7}$')

plot(x0,airy.gHk2(x0),label='Full linear')
#plot(x0,zct.gHk2(x0),label='$\\alpha=1-\\frac{1}{5}\\sqrt{5}$')
#plot(x0,lpt1.gHk2(x0),label='$\\alpha=0$')
#plot(x0,lpt2.gHk2(x0),label='$6^{th}$-order $\\alpha=1$')
#plot(x0,lpt3.gHk2(x0),label='$4^{th}$-order $\\alpha=1$')
#plot(x0,lpt4.gHk2(x0),label='$6^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7}$')
#plot(x0,lpt5.gHk2(x0),label='T-I $4^{th}$-order $\\alpha=1-\\frac{1}{6}\\sqrt{6}$')
plot(x0,lpt6.gHk2tau(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{6}\\sqrt{6},$\n$\\beta_1=$'+str(beta_1)+',$\\beta_2=$'+str(beta_2))
#plot(x0,lpt7.gHk2tau(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{6}\\sqrt{6},$\n$\\beta_1=$'+str(beta_11)+',$\\beta_2=$'+str(beta_21))
plot(x0,lpt8.gHk2tau(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{5}\\sqrt{5},$\n$\\beta_1=$'+str(beta_1)+',$\\beta_2=$'+str(beta_2))
#plot(x0,lpt9.gHk2tau(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{5}\\sqrt{5},$\n$\\beta_1=$'+str(beta_11)+',$\\beta_2=$'+str(beta_21))
plot(x0,lpt10.gHk2tau(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7},$\n$\\beta_1=$'+str(beta_1)+',$\\beta_2=$'+str(beta_2))

#plot(x0,airy.ik2wnu2(x0),label='Full linear ')
#plot(x0,zct.ik2wnu1(x0),label='$\\alpha=1-\\frac{1}{5}\\sqrt{5}$')
#plot(x0,lpt1.ik2wnu1(x0),label='$\\alpha=0$')
#plot(x0,lpt2.ik2wnu1(x0),label='$6^{th}$-order $\\alpha=1$')
#plot(x0,lpt3.ik2wnu1(x0),label='$4^{th}$-order $\\alpha=1$')
#plot(x0,lpt4.ik2wnu1(x0),label='$6^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7}$')
#plot(x0,lpt5.ik2wnu1(x0),label='T-I $4^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7}$')
#plot(x0,lpt6.ik2wnu2(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{5}\\sqrt{5},$\n$\\beta_1=$'+str(beta_1)+',$\\beta_2=$'+str(beta_2))
#plot(x0,lpt7.ik2wnu2(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{5}\\sqrt{5},$\n$\\beta_1=$'+str(beta_11)+',$\\beta_2=$'+str(beta_21))


#plot(x0,airy.nu1nu2k4(x0),label='Full linear ')
#plot(x0,zct.nu1nu2k4(x0),label='$\\alpha=1-\\frac{1}{5}\\sqrt{5}$')
#plot(x0,lpt1.nu1nu2k4(x0),label='$\\alpha=0$')
#plot(x0,lpt2.nu1nu2k4(x0),label='$6^{th}$-order $\\alpha=1$')
#plot(x0,lpt3.nu1nu2k4(x0),label='$4^{th}$-order $\\alpha=1$')
#plot(x0,lpt4.nu1nu2k4(x0),label='$6^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7}$')
#plot(x0,lpt5.nu1nu2k4(x0),label='$4^{th}$-order $\\alpha=1-\\frac{1}{7}\\sqrt{7}$')
#plot(x0,lpt6.nu1nu2k4(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{6}\\sqrt{6},$\n$\\beta_1=$'+str(beta_1)+',$\\beta_2=$'+str(beta_2))
#plot(x0,lpt7.nu1nu2k4(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{6}\\sqrt{6},$\n$\\beta_1=$'+str(beta_11)+',$\\beta_2=$'+str(beta_21))
#plot(x0,lpt8.nu1nu2k4(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{5}\\sqrt{5},$\n$\\beta_1=$'+str(beta_1)+',$\\beta_2=$'+str(beta_2))
#plot(x0,lpt9.nu1nu2k4(x0),label='T-II $4^{th}$-order $\\alpha=1-\\frac{1}{5}\\sqrt{5},$\n$\\beta_1=$'+str(beta_11)+',$\\beta_2=$'+str(beta_21))


#plot(x0,(1.+0.01*x0**2)*tanh(x0)/x0,label='$\\tau=0.01$')
#plot(x0,(1.+0.001*x0**2)*tanh(x0)/x0,label='$\\tau=0.001$')
#plot(x0,tanh(x0)/x0,label='$\\tau=0$')

legend(loc=1)

show()

