#!/usr/bin/env python

from pylab import *

#My classes
from airy import *
from zct import *
from lptt16o import *
from lptt14o import *
from lptt26o import *
from lptt24o import *

#ranges
x0=arange(0.0,20.,0.1)

#alpha definition
alpha=0.6220355269
beta=0.1

################## PLOT COMMANDS #######################
airy=AIRY(0.1)
zct=ZCT()
lptt16o=LPTt16o(alpha)
lptt14o=LPTt14o(alpha)
lptt26o=LPTt26o(alpha,beta)
lptt24o=LPTt24o(alpha,beta)
print '''
        *************************************************
           Fixed value of $\\alpha$ for all LPT models\n
                   No dissipative terms\n
                   Surface tension terms\n
        **************************************************'''

figure(1)
subplots_adjust(left=0.10,right=0.90,top=0.80, bottom=0.25)
subplot(111)

xlabel('$kH$')
ylabel('$C_p/\sqrt{gH}$')
TITLE='Scaled Phase Velocity\n Type-I,II $\\alpha=$'+str(alpha)+'\n' 'Type-II $\\beta=$'+str(beta)
title(TITLE)

plot(x0,airy.phase(x0),label='airy')
plot(x0,zct.phase(x0),label='zct')
plot(x0,lptt16o.phase(x0),label='T-I 6-o')
plot(x0,lptt14o.phase(x0),label='T-I 4-o')
plot(x0,lptt26o.phase(x0),label='T-II 6-o')
plot(x0,lptt24o.phase(x0),label='T-II 4-o')
legend(loc=1)

show()
