from pylab import *
# Zhao Cheng & Teng Second Order Model (\tau=\nu_1=\nu_2=0)

# Auxiliar generic phase velocity
def phase(a,b,c,d,x):
    return sqrt((1.-a*x**2+b*x**4)/(1-c*x**2+d*x**4))

#generic group velocity
def group(a,b,c,d,x):
    return sqrt((1.-a*x**2+b*x**4)/(1-c*x**2+d*x**4))+\
           ((4.*b*x**4-2.*a*x**2)/(1-c*x**2+d*x**4)-\
            (4.*d*x**4-2.*c*x**2)*(1.-a*x**2+b*x**4)/\
            (1-c*x**2+d*x**4)**2)/\
            (2.*sqrt((1.-a*x**2+b*x**4)/(1-c*x**2+d*x**4)))

class ZCT:
    def __init__(self):
        print 'zct class'
    #zhao cheng teng model
    def phase(self,x):
        return sqrt((1.+x**2/15.)/(1.+2.*x**2/5))

    def group(self,x):
        a=-1./15.
        b=0.
        c=-2./5.
        d=0.
        return group(a,b,c,d,x)
    

    def c1(self,x):
        return 2.*(1.+2./15.*x**2+2./75.*x**4)
    
    def c2(self,x):
        return (1.+2./5.*x**2+2./15.*x**4)
    
    def c3(self,x):
        return (1.-2./5.*x**2+2./25.*x**4) 
    
    def c4(self,x):
        return (1.+1./5.*x**2+2./75.*x**4)/\
               (2.*(1.+1./15.*x**2+1./75.*x**4))
    
    def shoal(self,x):
        return (self.c3(x)-self.c2(x)*self.c4(x))/self.c1(x)
