// {{{  Copyright (C) 2009 Nuno David Lopes.-----------------------------------
//
// e-mail: ndl@ptmat.fc.ul.pt
// http://ptmat.fc.ul.pt/~ndl/
//
// ---------------------------------------------------------------------------
// Licensed under the GNU LGPL Version 3.0 or later.
//
// ---------------------------------------------------------------------------
//  main.cpp
//
//  This program provides a demo of the DOLFWAVE library.
//  Matrix Plot Function (FunFunction.cpp). 
//
// --------------------------------------------------------------------------
// }}}------------------------------------------------------------------------

// {{{ Includes --------------------------------------------------------------
#include "../../src/dolfwave.h"
using namespace dolfin;
using namespace dolfin::dolfwave;
// }}} -----------------------------------------------------------------------

int main()
{
 
  // {{{User dependent information
  //  Mesh and boundary definition
  UnitCircle mesh(10);
  mesh.order();
  plot(mesh);

  // Constant functions
  Constant depth(1.0);//Depth
  FunctionSpace *V;
  SubSpace *V0,*V1;
  FunctionSpaceInit("Zhao",mesh,V,V0,V1);
  // }}}
  
  
  // {{{ Functions, Vectors and Matrices ----------------------
  Matrix M;
  Form *a;
  BilinearFormInit("Zhao",*V,a,depth);
  assemble(M,*a);  
  MatrixPlot(M,"matrix.pbm");
  // }}} -------------------------------------------------------
  return EXIT_SUCCESS;
}
