// {{{ Copyright (C) 2009 Nuno David Lopes.-----------------------------------
//
// e-mail: ndl@ptmat.fc.ul.pt
// http://ptmat.fc.ul.pt/~ndl/
//
// ---------------------------------------------------------------------------
// Licensed under the GNU LGPL Version 3.0 or later.
//
// ---------------------------------------------------------------------------
//  dolfwave.h
//
// First added:  2009-04-14
// Compiled with DOLFIN:0.9.2
// }}}------------------------------------------------------------------------

#include"DolfwaveClass.h"

using namespace dolfin;
using namespace dolfin::dolfwave;

// {{{Predictor Corrector interface ---------------------


void dolfin::dolfwave::Dolfwave::PCInit( )
{
  //Control Predictor-Corrector options here
  
  if (PcEpsilon>0.0)
    // Multi-Step  corrector
    pc = new PredCorr(*V0,eta_phi,PcEpsilon);  
  else
    //One step corrector
    pc = new PredCorr( );
 
   
  pc->disp();
  
} 



void dolfin::dolfwave::Dolfwave::PCSolve( )
{
  if(!(dbcapply))
    pc->solve(pcrk_b,L,*M,eta_phi,eta,phi,
              TimeStep,lu,Time);
  else //apply dirichlet boundary condition
    pc->solve(pcrk_b,L,*M,eta_phi,eta,phi,
              TimeStep,*dbc,lu,*Mf,Time);
  
  TimeUpdate();
}

// }}}-------------------------------------------------


