// {{{ Copyright (C) 2009 Nuno David Lopes.-----------------------------------
//
// e-mail: ndl@ptmat.fc.ul.pt
// http://ptmat.fc.ul.pt/~ndl/
//
// ---------------------------------------------------------------------------
// Licensed under the GNU LGPL Version 3.0 or later.
//
// ---------------------------------------------------------------------------
//  dolfwave.h
//
// First added:  2009-04-14
// Compiled with DOLFIN:0.9.2
// }}}------------------------------------------------------------------------

#include"DolfwaveClass.h"

using namespace dolfin;
using namespace dolfin::dolfwave;




// {{{Runge Kutta interface ---------------------


void dolfin::dolfwave::Dolfwave::RKSolve( )
{
  //Control RungeKutta options here
  
  RungeKutta rk(RungeKutta::euler);
  rk.disp();
  if(!(dbcapply))
    rk.solve(pcrk_b,L,*M,eta_phi,eta,phi,
             TimeStep,lu,Time);
  else //apply dirichlet boundary condition
    rk.solve(pcrk_b,L,*M,eta_phi,eta,phi,
             TimeStep,*dbc,lu,*Mf,Time);
}

// }}}-------------------------------------------------



