#include <dolfin.h>
#include <fstream> //for ofstream File saving
#include <string> //for string 

#include "MatrixSparsityPlot.h"

using namespace dolfin;

// {{{ Ploting matrix structures in a pbm format
void MatrixSparsityPlot(const Matrix &M,const std::string name) 
{
  int cor;
  int preto=1;
  int branco=0;
  
  //The fact that the number of rows cames first than the number of lines as to do with the pbm format
  std::ofstream fich_image(name.c_str( ));
  fich_image<<"P1"<<std::endl;
  fich_image<<M.size(1)<<"\t"<<M.size(0)<<std::endl;
  for(dolfin::uint i=0;i<M.size(1);i++)
    {
      for(dolfin::uint j=0;j<M.size(0);j++)
        {
          if(M(j,i)) cor=preto; else cor=branco;
                fich_image<<cor<<" ";
                if(!(j%70)) fich_image<<std::endl;
        }
      fich_image<<std::endl;
    }
  fich_image.close( );
  message("pbm image done");
}
