// This code conforms with the UFC specification version 1.0
// and was automatically generated by FFC version 0.6.2.
//
// Warning: This code was generated with the option '-l dolfin'
// and contains DOLFIN-specific wrappers that depend on DOLFIN.

#ifndef __LPTCDGI_H
#define __LPTCDGI_H

#include <cmath>
#include <stdexcept>
#include <fstream>
#include <ufc.h>
    
/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_0_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_0_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_0_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_0_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_0_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_0_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_0_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_0_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "MixedElement([FiniteElement('Lagrange', 'triangle', 2), FiniteElement('Lagrange', 'triangle', 2)])";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 12;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 5)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
    }
    
    if (6 <= i && i <= 11)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 6;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 5)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {4.89897948556635, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0},
      {0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (6 <= i && i <= 11)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 6;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {4.89897948556635, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0},
      {0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[12][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}, {{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[12][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[12][1][2] = {{{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[6];
    vertex_values[3] = dof_values[7];
    vertex_values[5] = dof_values[8];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_finite_element_0_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_finite_element_0_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_1_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_1_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_1_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_1_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_1_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_1_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_1_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_1_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "MixedElement([FiniteElement('Lagrange', 'triangle', 2), FiniteElement('Lagrange', 'triangle', 2)])";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 12;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 5)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
    }
    
    if (6 <= i && i <= 11)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 6;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 5)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {4.89897948556635, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0},
      {0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (6 <= i && i <= 11)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 6;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {4.89897948556635, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0},
      {0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[12][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}, {{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[12][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[12][1][2] = {{{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[6];
    vertex_values[3] = dof_values[7];
    vertex_values[5] = dof_values[8];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_finite_element_1_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_finite_element_1_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_2: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_2()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_2();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_3_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_3_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_3_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_3_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_3_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_3_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_3_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_3_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_3: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_3() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_3()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "MixedElement([FiniteElement('Discontinuous Lagrange', 'triangle', 0), FiniteElement('Discontinuous Lagrange', 'triangle', 0)])";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 2;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 0)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0;
    }
    
    if (1 <= i && i <= 1)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 1;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 0)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[1][1] =   \
      {{0}};
    
      const static double dmats1[1][1] =   \
      {{0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (1 <= i && i <= 1)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 1;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[1][1] =   \
      {{0}};
    
      const static double dmats1[1][1] =   \
      {{0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[2][1][2] = {{{0.333333333333333, 0.333333333333333}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[2][1] = {{1}, {1}};
    const static double D[2][1][2] = {{{1, 0}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[0];
    vertex_values[4] = dof_values[0];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[1];
    vertex_values[3] = dof_values[1];
    vertex_values[5] = dof_values[1];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_finite_element_3_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_finite_element_3_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_4: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_4() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_4()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_4();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgIBilinearForm_finite_element_5: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_finite_element_5() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_finite_element_5()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_finite_element_5();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_0_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_0_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_0_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_0_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_0_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_0_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_0_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_0_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for MixedElement([FiniteElement('Lagrange', 'triangle', 2), FiniteElement('Lagrange', 'triangle', 2)])";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[0] + 2*m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 12;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 6;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
    offset = offset + m.num_entities[1];
    dofs[6] = offset + c.entity_indices[0][0];
    dofs[7] = offset + c.entity_indices[0][1];
    dofs[8] = offset + c.entity_indices[0][2];
    offset = offset + m.num_entities[0];
    dofs[9] = offset + c.entity_indices[1][0];
    dofs[10] = offset + c.entity_indices[1][1];
    dofs[11] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 7;
      dofs[4] = 8;
      dofs[5] = 9;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      dofs[3] = 6;
      dofs[4] = 8;
      dofs[5] = 10;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      dofs[3] = 6;
      dofs[4] = 7;
      dofs[5] = 11;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
    coordinates[6][0] = x[0][0];
    coordinates[6][1] = x[0][1];
    coordinates[7][0] = x[1][0];
    coordinates[7][1] = x[1][1];
    coordinates[8][0] = x[2][0];
    coordinates[8][1] = x[2][1];
    coordinates[9][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[9][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[10][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[10][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[11][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[11][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_dof_map_0_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_dof_map_0_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_1_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_1_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_1_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_1_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_1_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_1_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_1_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_1_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for MixedElement([FiniteElement('Lagrange', 'triangle', 2), FiniteElement('Lagrange', 'triangle', 2)])";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[0] + 2*m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 12;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 6;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
    offset = offset + m.num_entities[1];
    dofs[6] = offset + c.entity_indices[0][0];
    dofs[7] = offset + c.entity_indices[0][1];
    dofs[8] = offset + c.entity_indices[0][2];
    offset = offset + m.num_entities[0];
    dofs[9] = offset + c.entity_indices[1][0];
    dofs[10] = offset + c.entity_indices[1][1];
    dofs[11] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 7;
      dofs[4] = 8;
      dofs[5] = 9;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      dofs[3] = 6;
      dofs[4] = 8;
      dofs[5] = 10;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      dofs[3] = 6;
      dofs[4] = 7;
      dofs[5] = 11;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
    coordinates[6][0] = x[0][0];
    coordinates[6][1] = x[0][1];
    coordinates[7][0] = x[1][0];
    coordinates[7][1] = x[1][1];
    coordinates[8][0] = x[2][0];
    coordinates[8][1] = x[2][1];
    coordinates[9][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[9][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[10][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[10][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[11][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[11][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_dof_map_1_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_dof_map_1_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_2: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_2() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_2()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_2();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_3_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_3_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_3_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_3_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_3_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_3_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_3_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_3_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_3: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_3() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_3()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for MixedElement([FiniteElement('Discontinuous Lagrange', 'triangle', 0), FiniteElement('Discontinuous Lagrange', 'triangle', 0)])";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 2;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
    unsigned int offset = m.num_entities[2];
    dofs[1] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[1][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[1][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_dof_map_3_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_dof_map_3_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_4: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_4() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_4()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_4();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgIBilinearForm_dof_map_5: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_dof_map_5() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_dof_map_5()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_dof_map_5();
  }

};

/// This class defines the interface for the tabulation of the cell
/// tensor corresponding to the local contribution to a form from
/// the integral over a cell.

class UFC_LPTcdgIBilinearForm_cell_integral_0_quadrature: public ufc::cell_integral
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_cell_integral_0_quadrature() : ufc::cell_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_cell_integral_0_quadrature()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local cell
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * x = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = x[1][0] - x[0][0];
    const double J_01 = x[2][0] - x[0][0];
    const double J_10 = x[1][1] - x[0][1];
    const double J_11 = x[2][1] - x[0][1];
      
    // Compute determinant of Jacobian
    double detJ = J_00*J_11 - J_01*J_10;
      
    // Compute inverse of Jacobian
    const double Jinv_00 =  J_11 / detJ;
    const double Jinv_01 = -J_01 / detJ;
    const double Jinv_10 = -J_10 / detJ;
    const double Jinv_11 =  J_00 / detJ;
    
    // Set scale factor
    const double det = std::abs(detJ);
    
    
    // Array of quadrature weights
    const static double W9[9] = {0.0558144204830443, 0.063678085099885, 0.0193963833059595, 0.0893030727728709, 0.101884936159816, 0.0310342132895351, 0.0558144204830443, 0.063678085099885, 0.0193963833059595};
    
    
    const static double FE0[9][6] = \
    {{0.499278833175498, -0.0816158215904472, -0.072892306371455, 0.0363981897820603, 0.286562341986258, 0.332268763018086},
    {0.0251290590975511, -0.0576951799472843, -0.0741406382908807, 0.109006741895515, 0.858208263567716, 0.139491753677383},
    {-0.117413197449647, -0.0227857341019971, 0.453155393641927, 0.0753983311062782, 0.593609805131561, 0.0180354016718772},
    {-0.0403700664710398, -0.0403700664710398, -0.072892306371455, 0.161480265884159, 0.161480265884159, 0.830671907545217},
    {-0.120901875682904, -0.120901875682904, -0.0741406382908807, 0.483607502731615, 0.483607502731615, 0.348729384193458},
    {-0.0836260170297299, -0.0836260170297299, 0.453155393641927, 0.33450406811892, 0.33450406811892, 0.0450885041796932},
    {-0.0816158215904472, 0.499278833175498, -0.072892306371455, 0.286562341986258, 0.0363981897820602, 0.332268763018086},
    {-0.0576951799472843, 0.0251290590975512, -0.0741406382908807, 0.858208263567716, 0.109006741895515, 0.139491753677383},
    {-0.0227857341019971, -0.117413197449647, 0.453155393641927, 0.593609805131561, 0.0753983311062784, 0.0180354016718773}};
    
    const static double FE1_C0[9][12] = \
    {{0.499278833175498, -0.0816158215904472, -0.072892306371455, 0.0363981897820603, 0.286562341986258, 0.332268763018086, 0, 0, 0, 0, 0, 0},
    {0.0251290590975511, -0.0576951799472843, -0.0741406382908807, 0.109006741895515, 0.858208263567716, 0.139491753677383, 0, 0, 0, 0, 0, 0},
    {-0.117413197449647, -0.0227857341019971, 0.453155393641927, 0.0753983311062782, 0.593609805131561, 0.0180354016718772, 0, 0, 0, 0, 0, 0},
    {-0.0403700664710398, -0.0403700664710398, -0.072892306371455, 0.161480265884159, 0.161480265884159, 0.830671907545217, 0, 0, 0, 0, 0, 0},
    {-0.120901875682904, -0.120901875682904, -0.0741406382908807, 0.483607502731615, 0.483607502731615, 0.348729384193458, 0, 0, 0, 0, 0, 0},
    {-0.0836260170297299, -0.0836260170297299, 0.453155393641927, 0.33450406811892, 0.33450406811892, 0.0450885041796932, 0, 0, 0, 0, 0, 0},
    {-0.0816158215904472, 0.499278833175498, -0.072892306371455, 0.286562341986258, 0.0363981897820602, 0.332268763018086, 0, 0, 0, 0, 0, 0},
    {-0.0576951799472843, 0.0251290590975512, -0.0741406382908807, 0.858208263567716, 0.109006741895515, 0.139491753677383, 0, 0, 0, 0, 0, 0},
    {-0.0227857341019971, -0.117413197449647, 0.453155393641927, 0.593609805131561, 0.0753983311062784, 0.0180354016718773, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_C1_D01[9][12] = \
    {{0, 0, 0, 0, 0, 0, -2.23477754271068, 0, -0.645648161949184, 0.410870619238505, 2.88042570465986, -0.410870619238505},
    {0, 0, 0, 0, 0, 0, -1.0959162708804, 0, 0.637867457762939, 0.266216271356658, 0.458048813117464, -0.266216271356658},
    {0, 0, 0, 0, 0, 0, 0.246362376191712, 0, 2.15063784704339, 0.0957245291483225, -2.3970002232351, -0.0957245291483228},
    {0, 0, 0, 0, 0, 0, -0.822824080974592, 0, -0.645648161949184, 1.82282408097459, 1.46847224292378, -1.82282408097459},
    {0, 0, 0, 0, 0, 0, -0.181066271118531, 0, 0.637867457762939, 1.18106627111853, -0.456801186644408, -1.18106627111853},
    {0, 0, 0, 0, 0, 0, 0.575318923521695, 0, 2.15063784704339, 0.424681076478306, -2.72595677056508, -0.424681076478306},
    {0, 0, 0, 0, 0, 0, 0.589129380761496, 0, -0.645648161949184, 3.23477754271068, 0.0565187811876886, -3.23477754271068},
    {0, 0, 0, 0, 0, 0, 0.733783728643342, 0, 0.637867457762939, 2.0959162708804, -1.37165118640628, -2.0959162708804},
    {0, 0, 0, 0, 0, 0, 0.904275470851678, 0, 2.15063784704339, 0.753637623808289, -3.05491331789507, -0.753637623808289}};
    
    const static double FE1_C1_D02[9][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -7.99999999999999, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0}};
    
    const static double FE1_C1_D11[9][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 0, 0, 4, -4, -3.99999999999999},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4}};
    
    const static double FE1_C1_D10[9][12] = \
    {{0, 0, 0, 0, 0, 0, -2.23477754271068, -0.589129380761495, 0, 0.354351838050816, -0.354351838050816, 2.82390692347217},
    {0, 0, 0, 0, 0, 0, -1.0959162708804, -0.733783728643342, 0, 1.63786745776294, -1.63786745776294, 1.82969999952374},
    {0, 0, 0, 0, 0, 0, 0.246362376191712, -0.904275470851677, 0, 3.15063784704339, -3.15063784704339, 0.657913094659966},
    {0, 0, 0, 0, 0, 0, -0.822824080974592, 0.822824080974592, 0, 0.354351838050816, -0.354351838050816, 0},
    {0, 0, 0, 0, 0, 0, -0.181066271118531, 0.181066271118531, 0, 1.63786745776294, -1.63786745776294, 0},
    {0, 0, 0, 0, 0, 0, 0.575318923521695, -0.575318923521694, 0, 3.15063784704339, -3.15063784704339, 0},
    {0, 0, 0, 0, 0, 0, 0.589129380761496, 2.23477754271068, 0, 0.354351838050816, -0.354351838050816, -2.82390692347218},
    {0, 0, 0, 0, 0, 0, 0.733783728643342, 1.0959162708804, 0, 1.63786745776294, -1.63786745776294, -1.82969999952374},
    {0, 0, 0, 0, 0, 0, 0.904275470851678, -0.246362376191711, 0, 3.15063784704339, -3.15063784704339, -0.657913094659967}};
    
    const static double FE1_C1_D20[9][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -7.99999999999999},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 4, 0, 0, 0, -7.99999999999999},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 4, 0, 0, 0, -7.99999999999999}};
    
    const static double FE1_C1[9][12] = \
    {{0, 0, 0, 0, 0, 0, 0.499278833175498, -0.0816158215904472, -0.072892306371455, 0.0363981897820603, 0.286562341986258, 0.332268763018086},
    {0, 0, 0, 0, 0, 0, 0.0251290590975511, -0.0576951799472843, -0.0741406382908807, 0.109006741895515, 0.858208263567716, 0.139491753677383},
    {0, 0, 0, 0, 0, 0, -0.117413197449647, -0.0227857341019971, 0.453155393641927, 0.0753983311062782, 0.593609805131561, 0.0180354016718772},
    {0, 0, 0, 0, 0, 0, -0.0403700664710398, -0.0403700664710398, -0.072892306371455, 0.161480265884159, 0.161480265884159, 0.830671907545217},
    {0, 0, 0, 0, 0, 0, -0.120901875682904, -0.120901875682904, -0.0741406382908807, 0.483607502731615, 0.483607502731615, 0.348729384193458},
    {0, 0, 0, 0, 0, 0, -0.0836260170297299, -0.0836260170297299, 0.453155393641927, 0.33450406811892, 0.33450406811892, 0.0450885041796932},
    {0, 0, 0, 0, 0, 0, -0.0816158215904472, 0.499278833175498, -0.072892306371455, 0.286562341986258, 0.0363981897820602, 0.332268763018086},
    {0, 0, 0, 0, 0, 0, -0.0576951799472843, 0.0251290590975512, -0.0741406382908807, 0.858208263567716, 0.109006741895515, 0.139491753677383},
    {0, 0, 0, 0, 0, 0, -0.0227857341019971, -0.117413197449647, 0.453155393641927, 0.593609805131561, 0.0753983311062784, 0.0180354016718773}};
    
    // Compute element tensor using UFL quadrature representation
    // Optimisations: ('simplify expressions', False), ('ignore zero tables', False), ('non zero columns', False), ('remove zero terms', False), ('ignore ones', False)
    // Total number of operations to compute element tensor: 101196
    
    // Loop quadrature points for integral
    // Number of operations to compute element tensor for following IP loop = 101196
    for (unsigned int ip = 0; ip < 9; ip++)
    {
      
      // Function declarations
      double F0 = 0;
      
      // Total number of operations to compute function values = 12
      for (unsigned int r = 0; r < 6; r++)
      {
        F0 += FE0[ip][r]*w[0][r];
      }// end loop over 'r'
      
      // Number of operations for primary indices = 11232
      for (unsigned int j = 0; j < 12; j++)
      {
        for (unsigned int k = 0; k < 12; k++)
        {
          // Number of operations to compute entry = 78
          A[j*12 + k] += (((Jinv_00*Jinv_00*FE1_C1_D20[ip][k] + Jinv_00*Jinv_10*FE1_C1_D11[ip][k] + Jinv_10*Jinv_00*FE1_C1_D11[ip][k] + Jinv_10*Jinv_10*FE1_C1_D02[ip][k]) + (Jinv_01*Jinv_01*FE1_C1_D20[ip][k] + Jinv_01*Jinv_11*FE1_C1_D11[ip][k] + Jinv_11*Jinv_01*FE1_C1_D11[ip][k] + Jinv_11*Jinv_11*FE1_C1_D02[ip][k]))*F0*F0*F0*0.00555555555555556*F0*((Jinv_00*Jinv_00*FE1_C1_D20[ip][j] + Jinv_00*Jinv_10*FE1_C1_D11[ip][j] + Jinv_10*Jinv_00*FE1_C1_D11[ip][j] + Jinv_10*Jinv_10*FE1_C1_D02[ip][j]) + (Jinv_01*Jinv_01*FE1_C1_D20[ip][j] + Jinv_01*Jinv_11*FE1_C1_D11[ip][j] + Jinv_11*Jinv_01*FE1_C1_D11[ip][j] + Jinv_11*Jinv_11*FE1_C1_D02[ip][j])) + (((Jinv_00*FE1_C1_D10[ip][j] + Jinv_10*FE1_C1_D01[ip][j])*(Jinv_00*FE1_C1_D10[ip][k] + Jinv_10*FE1_C1_D01[ip][k]) + (Jinv_01*FE1_C1_D10[ip][j] + Jinv_11*FE1_C1_D01[ip][j])*(Jinv_01*FE1_C1_D10[ip][k] + Jinv_11*FE1_C1_D01[ip][k]))*F0*0.416666666666667*F0 + (FE1_C0[ip][j]*FE1_C0[ip][k] + FE1_C1[ip][j]*FE1_C1[ip][k])))*W9[ip]*det;
        }// end loop over 'k'
      }// end loop over 'j'
    }// end loop over 'ip'
  }

};

/// This class defines the interface for the tabulation of the cell
/// tensor corresponding to the local contribution to a form from
/// the integral over a cell.

class UFC_LPTcdgIBilinearForm_cell_integral_0: public ufc::cell_integral
{
private:

  UFC_LPTcdgIBilinearForm_cell_integral_0_quadrature integral_0_quadrature;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_cell_integral_0() : ufc::cell_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_cell_integral_0()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local cell
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c) const
  {
    // Reset values of the element tensor block
    A[0] = 0;
    A[1] = 0;
    A[2] = 0;
    A[3] = 0;
    A[4] = 0;
    A[5] = 0;
    A[6] = 0;
    A[7] = 0;
    A[8] = 0;
    A[9] = 0;
    A[10] = 0;
    A[11] = 0;
    A[12] = 0;
    A[13] = 0;
    A[14] = 0;
    A[15] = 0;
    A[16] = 0;
    A[17] = 0;
    A[18] = 0;
    A[19] = 0;
    A[20] = 0;
    A[21] = 0;
    A[22] = 0;
    A[23] = 0;
    A[24] = 0;
    A[25] = 0;
    A[26] = 0;
    A[27] = 0;
    A[28] = 0;
    A[29] = 0;
    A[30] = 0;
    A[31] = 0;
    A[32] = 0;
    A[33] = 0;
    A[34] = 0;
    A[35] = 0;
    A[36] = 0;
    A[37] = 0;
    A[38] = 0;
    A[39] = 0;
    A[40] = 0;
    A[41] = 0;
    A[42] = 0;
    A[43] = 0;
    A[44] = 0;
    A[45] = 0;
    A[46] = 0;
    A[47] = 0;
    A[48] = 0;
    A[49] = 0;
    A[50] = 0;
    A[51] = 0;
    A[52] = 0;
    A[53] = 0;
    A[54] = 0;
    A[55] = 0;
    A[56] = 0;
    A[57] = 0;
    A[58] = 0;
    A[59] = 0;
    A[60] = 0;
    A[61] = 0;
    A[62] = 0;
    A[63] = 0;
    A[64] = 0;
    A[65] = 0;
    A[66] = 0;
    A[67] = 0;
    A[68] = 0;
    A[69] = 0;
    A[70] = 0;
    A[71] = 0;
    A[72] = 0;
    A[73] = 0;
    A[74] = 0;
    A[75] = 0;
    A[76] = 0;
    A[77] = 0;
    A[78] = 0;
    A[79] = 0;
    A[80] = 0;
    A[81] = 0;
    A[82] = 0;
    A[83] = 0;
    A[84] = 0;
    A[85] = 0;
    A[86] = 0;
    A[87] = 0;
    A[88] = 0;
    A[89] = 0;
    A[90] = 0;
    A[91] = 0;
    A[92] = 0;
    A[93] = 0;
    A[94] = 0;
    A[95] = 0;
    A[96] = 0;
    A[97] = 0;
    A[98] = 0;
    A[99] = 0;
    A[100] = 0;
    A[101] = 0;
    A[102] = 0;
    A[103] = 0;
    A[104] = 0;
    A[105] = 0;
    A[106] = 0;
    A[107] = 0;
    A[108] = 0;
    A[109] = 0;
    A[110] = 0;
    A[111] = 0;
    A[112] = 0;
    A[113] = 0;
    A[114] = 0;
    A[115] = 0;
    A[116] = 0;
    A[117] = 0;
    A[118] = 0;
    A[119] = 0;
    A[120] = 0;
    A[121] = 0;
    A[122] = 0;
    A[123] = 0;
    A[124] = 0;
    A[125] = 0;
    A[126] = 0;
    A[127] = 0;
    A[128] = 0;
    A[129] = 0;
    A[130] = 0;
    A[131] = 0;
    A[132] = 0;
    A[133] = 0;
    A[134] = 0;
    A[135] = 0;
    A[136] = 0;
    A[137] = 0;
    A[138] = 0;
    A[139] = 0;
    A[140] = 0;
    A[141] = 0;
    A[142] = 0;
    A[143] = 0;
    
    // Add all contributions to element tensor
    integral_0_quadrature.tabulate_tensor(A, w, c);
  }

};

/// This class defines the interface for the tabulation of the
/// interior facet tensor corresponding to the local contribution to
/// a form from the integral over an interior facet.

class UFC_LPTcdgIBilinearForm_interior_facet_integral_0_quadrature: public ufc::interior_facet_integral
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_interior_facet_integral_0_quadrature() : ufc::interior_facet_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_interior_facet_integral_0_quadrature()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local interior facet
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c0,
                               const ufc::cell& c1,
                               unsigned int facet0,
                               unsigned int facet1) const
  {
    // Extract vertex coordinates
    const double * const * x0 = c0.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J0_00 = x0[1][0] - x0[0][0];
    const double J0_01 = x0[2][0] - x0[0][0];
    const double J0_10 = x0[1][1] - x0[0][1];
    const double J0_11 = x0[2][1] - x0[0][1];
      
    // Compute determinant of Jacobian
    double detJ0 = J0_00*J0_11 - J0_01*J0_10;
      
    // Compute inverse of Jacobian
    const double Jinv0_00 =  J0_11 / detJ0;
    const double Jinv0_01 = -J0_01 / detJ0;
    const double Jinv0_10 = -J0_10 / detJ0;
    const double Jinv0_11 =  J0_00 / detJ0;
    
    // Extract vertex coordinates
    const double * const * x1 = c1.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J1_00 = x1[1][0] - x1[0][0];
    const double J1_01 = x1[2][0] - x1[0][0];
    const double J1_10 = x1[1][1] - x1[0][1];
    const double J1_11 = x1[2][1] - x1[0][1];
      
    // Compute determinant of Jacobian
    double detJ1 = J1_00*J1_11 - J1_01*J1_10;
      
    // Compute inverse of Jacobian
    const double Jinv1_00 =  J1_11 / detJ1;
    const double Jinv1_01 = -J1_01 / detJ1;
    const double Jinv1_10 = -J1_10 / detJ1;
    const double Jinv1_11 =  J1_00 / detJ1;
    
    // Vertices on edges
    static unsigned int edge_vertices[3][2] = {{1, 2}, {0, 2}, {0, 1}};
    
    // Get vertices
    const unsigned int v0 = edge_vertices[facet0][0];
    const unsigned int v1 = edge_vertices[facet0][1];
    
    // Compute scale factor (length of edge scaled by length of reference interval)
    const double dx0 = x0[v1][0] - x0[v0][0];
    const double dx1 = x0[v1][1] - x0[v0][1];
    const double det = std::sqrt(dx0*dx0 + dx1*dx1);
    
    
    // Array of quadrature weights
    const static double W3[3] = {0.277777777777778, 0.444444444444444, 0.277777777777778};
    
    
    const static double FE0_f0[3][6] = \
    {{0, 0.687298334620742, -0.0872983346207417, 0.4, 0, 0},
    {0, 0, 0, 1, 0, 0},
    {0, -0.0872983346207416, 0.687298334620742, 0.4, 0, 0}};
    
    const static double FE0_f1[3][6] = \
    {{0.687298334620742, 0, -0.0872983346207417, 0, 0.4, 0},
    {0, 0, 0, 0, 1, 0},
    {-0.0872983346207417, 0, 0.687298334620742, 0, 0.4, 0}};
    
    const static double FE0_f2[3][6] = \
    {{0.687298334620742, -0.0872983346207417, 0, 0, 0, 0.4},
    {0, 0, 0, 0, 0, 1},
    {-0.0872983346207417, 0.687298334620742, 0, 0, 0, 0.4}};
    
    const static double FE1_f2_C1_D02[3][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -7.99999999999999, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -7.99999999999999, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -7.99999999999999, 0}};
    
    const static double FE1_f0_C1_D01[3][12] = \
    {{0, 0, 0, 0, 0, 0, 1, 0, -0.549193338482967, 3.54919333848297, -0.450806661517033, -3.54919333848297},
    {0, 0, 0, 0, 0, 0, 1, 0, 1, 2, -2, -2},
    {0, 0, 0, 0, 0, 0, 1, 0, 2.54919333848297, 0.450806661517033, -3.54919333848297, -0.450806661517033}};
    
    const static double FE1_f0_C1_D02[3][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 3.99999999999999, 0, -8, 0}};
    
    const static double FE1_f2_C1_D01[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, 0, -1, 0.450806661517034, 3.54919333848297, -0.450806661517033},
    {0, 0, 0, 0, 0, 0, -0.999999999999999, 0, -1, 2, 2, -2},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, 0, -1, 3.54919333848297, 0.450806661517032, -3.54919333848297}};
    
    const static double FE1_f1_C1_D10[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, -1, 0, 0.450806661517033, -0.450806661517033, 3.54919333848297},
    {0, 0, 0, 0, 0, 0, -0.999999999999999, -1, 0, 2, -2, 2},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, -1, 0, 3.54919333848297, -3.54919333848297, 0.450806661517032}};
    
    const static double FE1_f1_C1_D11[3][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4}};
    
    const static double FE1_f0_C1_D20[3][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 4, 0, 0, 0, -7.99999999999999}};
    
    const static double FE1_f2_C1_D20[3][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8}};
    
    const static double FE1_f2_C0_D01[3][12] = \
    {{-2.54919333848297, 0, -1, 0.450806661517034, 3.54919333848297, -0.450806661517033, 0, 0, 0, 0, 0, 0},
    {-0.999999999999999, 0, -1, 2, 2, -2, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, 0, -1, 3.54919333848297, 0.450806661517032, -3.54919333848297, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f1_C0_D10[3][12] = \
    {{-2.54919333848297, -1, 0, 0.450806661517033, -0.450806661517033, 3.54919333848297, 0, 0, 0, 0, 0, 0},
    {-0.999999999999999, -1, 0, 2, -2, 2, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, -1, 0, 3.54919333848297, -3.54919333848297, 0.450806661517032, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f0_C0_D10[3][12] = \
    {{1, 2.54919333848297, 0, 0.450806661517033, -0.450806661517033, -3.54919333848297, 0, 0, 0, 0, 0, 0},
    {1, 1, 0, 2, -2, -2, 0, 0, 0, 0, 0, 0},
    {1, -0.549193338482967, 0, 3.54919333848297, -3.54919333848297, -0.450806661517034, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f1_C0_D01[3][12] = \
    {{-2.54919333848297, 0, -0.549193338482967, 0, 3.09838667696593, 0, 0, 0, 0, 0, 0, 0},
    {-1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, 0, 2.54919333848297, 0, -3.09838667696594, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f2_C1_D11[3][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 0, 0, 4, -4, -3.99999999999999}};
    
    const static double FE1_f2_C1_D10[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, -0.549193338482967, 0, 0, 0, 3.09838667696593},
    {0, 0, 0, 0, 0, 0, -1, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, 2.54919333848297, 0, 0, 0, -3.09838667696594}};
    
    const static double FE1_f0_C1_D11[3][12] = \
    {{0, 0, 0, 0, 0, 0, 3.99999999999999, 0, 0, 4, -4, -3.99999999999999},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4}};
    
    const static double FE1_f0_C1_D10[3][12] = \
    {{0, 0, 0, 0, 0, 0, 1, 2.54919333848297, 0, 0.450806661517033, -0.450806661517033, -3.54919333848297},
    {0, 0, 0, 0, 0, 0, 1, 1, 0, 2, -2, -2},
    {0, 0, 0, 0, 0, 0, 1, -0.549193338482967, 0, 3.54919333848297, -3.54919333848297, -0.450806661517034}};
    
    const static double FE1_f1_C1_D01[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, 0, -0.549193338482967, 0, 3.09838667696593, 0},
    {0, 0, 0, 0, 0, 0, -1, 0, 1, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, 0, 2.54919333848297, 0, -3.09838667696594, 0}};
    
    const static double FE1_f2_C0_D10[3][12] = \
    {{-2.54919333848297, -0.549193338482967, 0, 0, 0, 3.09838667696593, 0, 0, 0, 0, 0, 0},
    {-1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, 2.54919333848297, 0, 0, 0, -3.09838667696594, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f0_C0_D01[3][12] = \
    {{1, 0, -0.549193338482967, 3.54919333848297, -0.450806661517033, -3.54919333848297, 0, 0, 0, 0, 0, 0},
    {1, 0, 1, 2, -2, -2, 0, 0, 0, 0, 0, 0},
    {1, 0, 2.54919333848297, 0.450806661517033, -3.54919333848297, -0.450806661517033, 0, 0, 0, 0, 0, 0}};
    
    // Compute element tensor using UFL quadrature representation
    // Optimisations: ('simplify expressions', False), ('ignore zero tables', False), ('non zero columns', False), ('remove zero terms', False), ('ignore ones', False)
    switch ( facet0 )
    {
    case 0:
      switch ( facet1 )
      {
      case 0:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f0[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f0_C0_D10[ip][k] + Jinv1_10*FE1_f0_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][k] + Jinv1_11*FE1_f0_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f0_C0_D10[ip][k] + Jinv0_10*FE1_f0_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][k] + Jinv0_11*FE1_f0_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f0_C0_D10[ip][k] + Jinv1_10*FE1_f0_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][k] + Jinv1_11*FE1_f0_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f0_C0_D10[ip][k] + Jinv0_10*FE1_f0_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][k] + Jinv0_11*FE1_f0_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 1:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f0[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f1_C0_D10[ip][k] + Jinv1_10*FE1_f1_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][k] + Jinv1_11*FE1_f1_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f0_C0_D10[ip][k] + Jinv0_10*FE1_f0_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][k] + Jinv0_11*FE1_f0_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f1_C0_D10[ip][k] + Jinv1_10*FE1_f1_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][k] + Jinv1_11*FE1_f1_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f0_C0_D10[ip][k] + Jinv0_10*FE1_f0_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][k] + Jinv0_11*FE1_f0_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 2:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f0[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f2_C0_D10[ip][k] + Jinv1_10*FE1_f2_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][k] + Jinv1_11*FE1_f2_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f0_C0_D10[ip][k] + Jinv0_10*FE1_f0_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][k] + Jinv0_11*FE1_f0_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f2_C0_D10[ip][k] + Jinv1_10*FE1_f2_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][k] + Jinv1_11*FE1_f2_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f0_C0_D10[ip][k] + Jinv0_10*FE1_f0_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C0_D10[ip][k] + Jinv0_11*FE1_f0_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][k] + Jinv0_10*FE1_f0_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][k] + Jinv0_11*FE1_f0_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f0_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f0_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      }
      break;
    case 1:
      switch ( facet1 )
      {
      case 0:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f1[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f0_C0_D10[ip][k] + Jinv1_10*FE1_f0_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][k] + Jinv1_11*FE1_f0_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f1_C0_D10[ip][k] + Jinv0_10*FE1_f1_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][k] + Jinv0_11*FE1_f1_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f0_C0_D10[ip][k] + Jinv1_10*FE1_f0_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][k] + Jinv1_11*FE1_f0_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f1_C0_D10[ip][k] + Jinv0_10*FE1_f1_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][k] + Jinv0_11*FE1_f1_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 1:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f1[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f1_C0_D10[ip][k] + Jinv1_10*FE1_f1_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][k] + Jinv1_11*FE1_f1_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f1_C0_D10[ip][k] + Jinv0_10*FE1_f1_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][k] + Jinv0_11*FE1_f1_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f1_C0_D10[ip][k] + Jinv1_10*FE1_f1_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][k] + Jinv1_11*FE1_f1_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f1_C0_D10[ip][k] + Jinv0_10*FE1_f1_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][k] + Jinv0_11*FE1_f1_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 2:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f1[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f2_C0_D10[ip][k] + Jinv1_10*FE1_f2_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][k] + Jinv1_11*FE1_f2_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f1_C0_D10[ip][k] + Jinv0_10*FE1_f1_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][k] + Jinv0_11*FE1_f1_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f2_C0_D10[ip][k] + Jinv1_10*FE1_f2_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][k] + Jinv1_11*FE1_f2_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f1_C0_D10[ip][k] + Jinv0_10*FE1_f1_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C0_D10[ip][k] + Jinv0_11*FE1_f1_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][k] + Jinv0_10*FE1_f1_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][k] + Jinv0_11*FE1_f1_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f0_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f1_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f0_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f0_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f1_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      }
      break;
    case 2:
      switch ( facet1 )
      {
      case 0:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f2[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f0_C0_D10[ip][k] + Jinv1_10*FE1_f0_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][k] + Jinv1_11*FE1_f0_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f2_C0_D10[ip][k] + Jinv0_10*FE1_f2_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][k] + Jinv0_11*FE1_f2_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f0_C0_D10[ip][k] + Jinv1_10*FE1_f0_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C0_D10[ip][k] + Jinv1_11*FE1_f0_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f0_C1_D10[ip][k] + Jinv1_10*FE1_f0_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f0_C1_D10[ip][k] + Jinv1_11*FE1_f0_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f0_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f0_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f2_C0_D10[ip][k] + Jinv0_10*FE1_f2_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][k] + Jinv0_11*FE1_f2_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 1:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f2[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f1_C0_D10[ip][k] + Jinv1_10*FE1_f1_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][k] + Jinv1_11*FE1_f1_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f2_C0_D10[ip][k] + Jinv0_10*FE1_f2_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][k] + Jinv0_11*FE1_f2_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f1_C0_D10[ip][k] + Jinv1_10*FE1_f1_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C0_D10[ip][k] + Jinv1_11*FE1_f1_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f1_C1_D10[ip][k] + Jinv1_10*FE1_f1_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f1_C1_D10[ip][k] + Jinv1_11*FE1_f1_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f0_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f1_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f0_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f0_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f1_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f0_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f2_C0_D10[ip][k] + Jinv0_10*FE1_f2_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][k] + Jinv0_11*FE1_f2_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 2:
        {
        // Total number of operations to compute element tensor (from this point): 214308
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 214308
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          
          // Total number of operations to compute function values = 12
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f2[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 71424
          for (unsigned int j = 0; j < 12; j++)
          {
            for (unsigned int k = 0; k < 12; k++)
            {
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + (k + 12)] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[1][3])*((Jinv1_00*FE1_f2_C0_D10[ip][k] + Jinv1_10*FE1_f2_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][k] + Jinv1_11*FE1_f2_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[(j + 12)*24 + k] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[1][3])*((Jinv0_00*FE1_f2_C0_D10[ip][k] + Jinv0_10*FE1_f2_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][k] + Jinv0_11*FE1_f2_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[1][3]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + (k + 12)] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[1][1])*((Jinv1_00*FE1_f2_C0_D10[ip][k] + Jinv1_10*FE1_f2_C0_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C0_D10[ip][k] + Jinv1_11*FE1_f2_C0_D01[ip][k])*w[1][3])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv1_00*FE1_f2_C1_D10[ip][k] + Jinv1_10*FE1_f2_C1_D01[ip][k])*w[1][2] + (Jinv1_01*FE1_f2_C1_D10[ip][k] + Jinv1_11*FE1_f2_C1_D01[ip][k])*w[1][3]) + ((Jinv1_00*Jinv1_00*FE1_f2_C1_D20[ip][k] + Jinv1_00*Jinv1_10*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_00*FE1_f2_C1_D11[ip][k] + Jinv1_10*Jinv1_10*FE1_f2_C1_D02[ip][k]) + (Jinv1_01*Jinv1_01*FE1_f2_C1_D20[ip][k] + Jinv1_01*Jinv1_11*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_01*FE1_f2_C1_D11[ip][k] + Jinv1_11*Jinv1_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
              // Number of operations to compute entry = 124
              A[j*24 + k] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[1][1])*((Jinv0_00*FE1_f2_C0_D10[ip][k] + Jinv0_10*FE1_f2_C0_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C0_D10[ip][k] + Jinv0_11*FE1_f2_C0_D01[ip][k])*w[1][1])*w[2][0]/(w[3][0]) + (((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][j]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][k] + Jinv0_10*FE1_f2_C1_D01[ip][k])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][k] + Jinv0_11*FE1_f2_C1_D01[ip][k])*w[1][1]) + ((Jinv0_00*Jinv0_00*FE1_f2_C1_D20[ip][k] + Jinv0_00*Jinv0_10*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_00*FE1_f2_C1_D11[ip][k] + Jinv0_10*Jinv0_10*FE1_f2_C1_D02[ip][k]) + (Jinv0_01*Jinv0_01*FE1_f2_C1_D20[ip][k] + Jinv0_01*Jinv0_11*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_01*FE1_f2_C1_D11[ip][k] + Jinv0_11*Jinv0_11*FE1_f2_C1_D02[ip][k]))*0.5*F0*F0*F0*-0.00555555555555556*F0*((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[1][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[1][1]))))*W3[ip]*det;
            }// end loop over 'k'
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      }
      break;
    }
  }

};

/// This class defines the interface for the tabulation of the
/// interior facet tensor corresponding to the local contribution to
/// a form from the integral over an interior facet.

class UFC_LPTcdgIBilinearForm_interior_facet_integral_0: public ufc::interior_facet_integral
{
private:

  UFC_LPTcdgIBilinearForm_interior_facet_integral_0_quadrature integral_0_quadrature;

public:

  /// Constructor
  UFC_LPTcdgIBilinearForm_interior_facet_integral_0() : ufc::interior_facet_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm_interior_facet_integral_0()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local interior facet
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c0,
                               const ufc::cell& c1,
                               unsigned int facet0,
                               unsigned int facet1) const
  {
    // Reset values of the element tensor block
    A[0] = 0;
    A[1] = 0;
    A[2] = 0;
    A[3] = 0;
    A[4] = 0;
    A[5] = 0;
    A[6] = 0;
    A[7] = 0;
    A[8] = 0;
    A[9] = 0;
    A[10] = 0;
    A[11] = 0;
    A[12] = 0;
    A[13] = 0;
    A[14] = 0;
    A[15] = 0;
    A[16] = 0;
    A[17] = 0;
    A[18] = 0;
    A[19] = 0;
    A[20] = 0;
    A[21] = 0;
    A[22] = 0;
    A[23] = 0;
    A[24] = 0;
    A[25] = 0;
    A[26] = 0;
    A[27] = 0;
    A[28] = 0;
    A[29] = 0;
    A[30] = 0;
    A[31] = 0;
    A[32] = 0;
    A[33] = 0;
    A[34] = 0;
    A[35] = 0;
    A[36] = 0;
    A[37] = 0;
    A[38] = 0;
    A[39] = 0;
    A[40] = 0;
    A[41] = 0;
    A[42] = 0;
    A[43] = 0;
    A[44] = 0;
    A[45] = 0;
    A[46] = 0;
    A[47] = 0;
    A[48] = 0;
    A[49] = 0;
    A[50] = 0;
    A[51] = 0;
    A[52] = 0;
    A[53] = 0;
    A[54] = 0;
    A[55] = 0;
    A[56] = 0;
    A[57] = 0;
    A[58] = 0;
    A[59] = 0;
    A[60] = 0;
    A[61] = 0;
    A[62] = 0;
    A[63] = 0;
    A[64] = 0;
    A[65] = 0;
    A[66] = 0;
    A[67] = 0;
    A[68] = 0;
    A[69] = 0;
    A[70] = 0;
    A[71] = 0;
    A[72] = 0;
    A[73] = 0;
    A[74] = 0;
    A[75] = 0;
    A[76] = 0;
    A[77] = 0;
    A[78] = 0;
    A[79] = 0;
    A[80] = 0;
    A[81] = 0;
    A[82] = 0;
    A[83] = 0;
    A[84] = 0;
    A[85] = 0;
    A[86] = 0;
    A[87] = 0;
    A[88] = 0;
    A[89] = 0;
    A[90] = 0;
    A[91] = 0;
    A[92] = 0;
    A[93] = 0;
    A[94] = 0;
    A[95] = 0;
    A[96] = 0;
    A[97] = 0;
    A[98] = 0;
    A[99] = 0;
    A[100] = 0;
    A[101] = 0;
    A[102] = 0;
    A[103] = 0;
    A[104] = 0;
    A[105] = 0;
    A[106] = 0;
    A[107] = 0;
    A[108] = 0;
    A[109] = 0;
    A[110] = 0;
    A[111] = 0;
    A[112] = 0;
    A[113] = 0;
    A[114] = 0;
    A[115] = 0;
    A[116] = 0;
    A[117] = 0;
    A[118] = 0;
    A[119] = 0;
    A[120] = 0;
    A[121] = 0;
    A[122] = 0;
    A[123] = 0;
    A[124] = 0;
    A[125] = 0;
    A[126] = 0;
    A[127] = 0;
    A[128] = 0;
    A[129] = 0;
    A[130] = 0;
    A[131] = 0;
    A[132] = 0;
    A[133] = 0;
    A[134] = 0;
    A[135] = 0;
    A[136] = 0;
    A[137] = 0;
    A[138] = 0;
    A[139] = 0;
    A[140] = 0;
    A[141] = 0;
    A[142] = 0;
    A[143] = 0;
    A[144] = 0;
    A[145] = 0;
    A[146] = 0;
    A[147] = 0;
    A[148] = 0;
    A[149] = 0;
    A[150] = 0;
    A[151] = 0;
    A[152] = 0;
    A[153] = 0;
    A[154] = 0;
    A[155] = 0;
    A[156] = 0;
    A[157] = 0;
    A[158] = 0;
    A[159] = 0;
    A[160] = 0;
    A[161] = 0;
    A[162] = 0;
    A[163] = 0;
    A[164] = 0;
    A[165] = 0;
    A[166] = 0;
    A[167] = 0;
    A[168] = 0;
    A[169] = 0;
    A[170] = 0;
    A[171] = 0;
    A[172] = 0;
    A[173] = 0;
    A[174] = 0;
    A[175] = 0;
    A[176] = 0;
    A[177] = 0;
    A[178] = 0;
    A[179] = 0;
    A[180] = 0;
    A[181] = 0;
    A[182] = 0;
    A[183] = 0;
    A[184] = 0;
    A[185] = 0;
    A[186] = 0;
    A[187] = 0;
    A[188] = 0;
    A[189] = 0;
    A[190] = 0;
    A[191] = 0;
    A[192] = 0;
    A[193] = 0;
    A[194] = 0;
    A[195] = 0;
    A[196] = 0;
    A[197] = 0;
    A[198] = 0;
    A[199] = 0;
    A[200] = 0;
    A[201] = 0;
    A[202] = 0;
    A[203] = 0;
    A[204] = 0;
    A[205] = 0;
    A[206] = 0;
    A[207] = 0;
    A[208] = 0;
    A[209] = 0;
    A[210] = 0;
    A[211] = 0;
    A[212] = 0;
    A[213] = 0;
    A[214] = 0;
    A[215] = 0;
    A[216] = 0;
    A[217] = 0;
    A[218] = 0;
    A[219] = 0;
    A[220] = 0;
    A[221] = 0;
    A[222] = 0;
    A[223] = 0;
    A[224] = 0;
    A[225] = 0;
    A[226] = 0;
    A[227] = 0;
    A[228] = 0;
    A[229] = 0;
    A[230] = 0;
    A[231] = 0;
    A[232] = 0;
    A[233] = 0;
    A[234] = 0;
    A[235] = 0;
    A[236] = 0;
    A[237] = 0;
    A[238] = 0;
    A[239] = 0;
    A[240] = 0;
    A[241] = 0;
    A[242] = 0;
    A[243] = 0;
    A[244] = 0;
    A[245] = 0;
    A[246] = 0;
    A[247] = 0;
    A[248] = 0;
    A[249] = 0;
    A[250] = 0;
    A[251] = 0;
    A[252] = 0;
    A[253] = 0;
    A[254] = 0;
    A[255] = 0;
    A[256] = 0;
    A[257] = 0;
    A[258] = 0;
    A[259] = 0;
    A[260] = 0;
    A[261] = 0;
    A[262] = 0;
    A[263] = 0;
    A[264] = 0;
    A[265] = 0;
    A[266] = 0;
    A[267] = 0;
    A[268] = 0;
    A[269] = 0;
    A[270] = 0;
    A[271] = 0;
    A[272] = 0;
    A[273] = 0;
    A[274] = 0;
    A[275] = 0;
    A[276] = 0;
    A[277] = 0;
    A[278] = 0;
    A[279] = 0;
    A[280] = 0;
    A[281] = 0;
    A[282] = 0;
    A[283] = 0;
    A[284] = 0;
    A[285] = 0;
    A[286] = 0;
    A[287] = 0;
    A[288] = 0;
    A[289] = 0;
    A[290] = 0;
    A[291] = 0;
    A[292] = 0;
    A[293] = 0;
    A[294] = 0;
    A[295] = 0;
    A[296] = 0;
    A[297] = 0;
    A[298] = 0;
    A[299] = 0;
    A[300] = 0;
    A[301] = 0;
    A[302] = 0;
    A[303] = 0;
    A[304] = 0;
    A[305] = 0;
    A[306] = 0;
    A[307] = 0;
    A[308] = 0;
    A[309] = 0;
    A[310] = 0;
    A[311] = 0;
    A[312] = 0;
    A[313] = 0;
    A[314] = 0;
    A[315] = 0;
    A[316] = 0;
    A[317] = 0;
    A[318] = 0;
    A[319] = 0;
    A[320] = 0;
    A[321] = 0;
    A[322] = 0;
    A[323] = 0;
    A[324] = 0;
    A[325] = 0;
    A[326] = 0;
    A[327] = 0;
    A[328] = 0;
    A[329] = 0;
    A[330] = 0;
    A[331] = 0;
    A[332] = 0;
    A[333] = 0;
    A[334] = 0;
    A[335] = 0;
    A[336] = 0;
    A[337] = 0;
    A[338] = 0;
    A[339] = 0;
    A[340] = 0;
    A[341] = 0;
    A[342] = 0;
    A[343] = 0;
    A[344] = 0;
    A[345] = 0;
    A[346] = 0;
    A[347] = 0;
    A[348] = 0;
    A[349] = 0;
    A[350] = 0;
    A[351] = 0;
    A[352] = 0;
    A[353] = 0;
    A[354] = 0;
    A[355] = 0;
    A[356] = 0;
    A[357] = 0;
    A[358] = 0;
    A[359] = 0;
    A[360] = 0;
    A[361] = 0;
    A[362] = 0;
    A[363] = 0;
    A[364] = 0;
    A[365] = 0;
    A[366] = 0;
    A[367] = 0;
    A[368] = 0;
    A[369] = 0;
    A[370] = 0;
    A[371] = 0;
    A[372] = 0;
    A[373] = 0;
    A[374] = 0;
    A[375] = 0;
    A[376] = 0;
    A[377] = 0;
    A[378] = 0;
    A[379] = 0;
    A[380] = 0;
    A[381] = 0;
    A[382] = 0;
    A[383] = 0;
    A[384] = 0;
    A[385] = 0;
    A[386] = 0;
    A[387] = 0;
    A[388] = 0;
    A[389] = 0;
    A[390] = 0;
    A[391] = 0;
    A[392] = 0;
    A[393] = 0;
    A[394] = 0;
    A[395] = 0;
    A[396] = 0;
    A[397] = 0;
    A[398] = 0;
    A[399] = 0;
    A[400] = 0;
    A[401] = 0;
    A[402] = 0;
    A[403] = 0;
    A[404] = 0;
    A[405] = 0;
    A[406] = 0;
    A[407] = 0;
    A[408] = 0;
    A[409] = 0;
    A[410] = 0;
    A[411] = 0;
    A[412] = 0;
    A[413] = 0;
    A[414] = 0;
    A[415] = 0;
    A[416] = 0;
    A[417] = 0;
    A[418] = 0;
    A[419] = 0;
    A[420] = 0;
    A[421] = 0;
    A[422] = 0;
    A[423] = 0;
    A[424] = 0;
    A[425] = 0;
    A[426] = 0;
    A[427] = 0;
    A[428] = 0;
    A[429] = 0;
    A[430] = 0;
    A[431] = 0;
    A[432] = 0;
    A[433] = 0;
    A[434] = 0;
    A[435] = 0;
    A[436] = 0;
    A[437] = 0;
    A[438] = 0;
    A[439] = 0;
    A[440] = 0;
    A[441] = 0;
    A[442] = 0;
    A[443] = 0;
    A[444] = 0;
    A[445] = 0;
    A[446] = 0;
    A[447] = 0;
    A[448] = 0;
    A[449] = 0;
    A[450] = 0;
    A[451] = 0;
    A[452] = 0;
    A[453] = 0;
    A[454] = 0;
    A[455] = 0;
    A[456] = 0;
    A[457] = 0;
    A[458] = 0;
    A[459] = 0;
    A[460] = 0;
    A[461] = 0;
    A[462] = 0;
    A[463] = 0;
    A[464] = 0;
    A[465] = 0;
    A[466] = 0;
    A[467] = 0;
    A[468] = 0;
    A[469] = 0;
    A[470] = 0;
    A[471] = 0;
    A[472] = 0;
    A[473] = 0;
    A[474] = 0;
    A[475] = 0;
    A[476] = 0;
    A[477] = 0;
    A[478] = 0;
    A[479] = 0;
    A[480] = 0;
    A[481] = 0;
    A[482] = 0;
    A[483] = 0;
    A[484] = 0;
    A[485] = 0;
    A[486] = 0;
    A[487] = 0;
    A[488] = 0;
    A[489] = 0;
    A[490] = 0;
    A[491] = 0;
    A[492] = 0;
    A[493] = 0;
    A[494] = 0;
    A[495] = 0;
    A[496] = 0;
    A[497] = 0;
    A[498] = 0;
    A[499] = 0;
    A[500] = 0;
    A[501] = 0;
    A[502] = 0;
    A[503] = 0;
    A[504] = 0;
    A[505] = 0;
    A[506] = 0;
    A[507] = 0;
    A[508] = 0;
    A[509] = 0;
    A[510] = 0;
    A[511] = 0;
    A[512] = 0;
    A[513] = 0;
    A[514] = 0;
    A[515] = 0;
    A[516] = 0;
    A[517] = 0;
    A[518] = 0;
    A[519] = 0;
    A[520] = 0;
    A[521] = 0;
    A[522] = 0;
    A[523] = 0;
    A[524] = 0;
    A[525] = 0;
    A[526] = 0;
    A[527] = 0;
    A[528] = 0;
    A[529] = 0;
    A[530] = 0;
    A[531] = 0;
    A[532] = 0;
    A[533] = 0;
    A[534] = 0;
    A[535] = 0;
    A[536] = 0;
    A[537] = 0;
    A[538] = 0;
    A[539] = 0;
    A[540] = 0;
    A[541] = 0;
    A[542] = 0;
    A[543] = 0;
    A[544] = 0;
    A[545] = 0;
    A[546] = 0;
    A[547] = 0;
    A[548] = 0;
    A[549] = 0;
    A[550] = 0;
    A[551] = 0;
    A[552] = 0;
    A[553] = 0;
    A[554] = 0;
    A[555] = 0;
    A[556] = 0;
    A[557] = 0;
    A[558] = 0;
    A[559] = 0;
    A[560] = 0;
    A[561] = 0;
    A[562] = 0;
    A[563] = 0;
    A[564] = 0;
    A[565] = 0;
    A[566] = 0;
    A[567] = 0;
    A[568] = 0;
    A[569] = 0;
    A[570] = 0;
    A[571] = 0;
    A[572] = 0;
    A[573] = 0;
    A[574] = 0;
    A[575] = 0;
    
    // Add all contributions to element tensor
    integral_0_quadrature.tabulate_tensor(A, w, c0, c1, facet0, facet1);
  }

};

/// This class defines the interface for the assembly of the global
/// tensor corresponding to a form with r + n arguments, that is, a
/// mapping
///
///     a : V1 x V2 x ... Vr x W1 x W2 x ... x Wn -> R
///
/// with arguments v1, v2, ..., vr, w1, w2, ..., wn. The rank r
/// global tensor A is defined by
///
///     A = a(V1, V2, ..., Vr, w1, w2, ..., wn),
///
/// where each argument Vj represents the application to the
/// sequence of basis functions of Vj and w1, w2, ..., wn are given
/// fixed functions (coefficients).

class UFC_LPTcdgIBilinearForm: public ufc::form
{
public:

  /// Constructor
  UFC_LPTcdgIBilinearForm() : ufc::form()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgIBilinearForm()
  {
    // Do nothing
  }

  /// Return a string identifying the form
  virtual const char* signature() const
  {
    return "Form([Integral(Sum(Product(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(0),))), MultiIndex((Index(1),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(1),))), MultiIndex((Index(0),))), MultiIndex((Index(0),))), Product(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(2),))), MultiIndex((Index(3),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(3),))), MultiIndex((Index(2),))), MultiIndex((Index(2),))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(FloatValue(0.0055555555555555636, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0))))))), Sum(Product(IndexSum(Product(Indexed(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(4),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(4),))), MultiIndex((Index(5),))), Indexed(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(6),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(6),))), MultiIndex((Index(5),)))), MultiIndex((Index(5),))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(FloatValue(0.41666666666666674, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0)))), Sum(Product(Indexed(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((FixedIndex(0),))), Indexed(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((FixedIndex(0),)))), Product(Indexed(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((FixedIndex(1),))), Indexed(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((FixedIndex(1),))))))), Measure('cell', 0, {'ffc_representation': 'quadrature', 'quadrature_order': 4})), Integral(Sum(Product(Division(PositiveRestricted(Constant(Cell('triangle', 1), 2)), PositiveRestricted(Constant(Cell('triangle', 1), 3))), Product(Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(7),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(7),)))), MultiIndex((Index(8),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(8),)))), MultiIndex((Index(8),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(9),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(9),)))), MultiIndex((Index(10),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(10),)))), MultiIndex((Index(10),)))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(11),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(11),)))), MultiIndex((Index(12),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(12),)))), MultiIndex((Index(12),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(13),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(13),)))), MultiIndex((Index(14),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(14),)))), MultiIndex((Index(14),)))))), Sum(Product(Division(PositiveRestricted(Constant(Cell('triangle', 1), 2)), PositiveRestricted(Constant(Cell('triangle', 1), 3))), Product(Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(15),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(15),)))), MultiIndex((Index(16),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(16),)))), MultiIndex((Index(16),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(17),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(17),)))), MultiIndex((Index(18),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(18),)))), MultiIndex((Index(18),)))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(19),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(19),)))), MultiIndex((Index(20),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(20),)))), MultiIndex((Index(20),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(21),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(21),)))), MultiIndex((Index(22),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(22),)))), MultiIndex((Index(22),)))))), Sum(Product(Product(Product(FloatValue(0.5, (), (), {}), Sum(NegativeRestricted(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(23),))), MultiIndex((Index(24),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(24),))), MultiIndex((Index(23),))), MultiIndex((Index(23),)))), PositiveRestricted(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(25),))), MultiIndex((Index(26),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(26),))), MultiIndex((Index(25),))), MultiIndex((Index(25),)))))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(FloatValue(-0.0055555555555555636, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0)))))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(27),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(27),)))), MultiIndex((Index(28),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(28),)))), MultiIndex((Index(28),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(29),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(29),)))), MultiIndex((Index(30),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(30),)))), MultiIndex((Index(30),))))), Product(Product(Product(FloatValue(0.5, (), (), {}), Sum(NegativeRestricted(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(31),))), MultiIndex((Index(32),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(32),))), MultiIndex((Index(31),))), MultiIndex((Index(31),)))), PositiveRestricted(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 1), MultiIndex((Index(33),))), MultiIndex((Index(34),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(34),))), MultiIndex((Index(33),))), MultiIndex((Index(33),)))))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(FloatValue(-0.0055555555555555636, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0)))))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(35),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(35),)))), MultiIndex((Index(36),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(36),)))), MultiIndex((Index(36),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(37),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(37),)))), MultiIndex((Index(38),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 1)), MultiIndex((Index(38),)))), MultiIndex((Index(38),)))))))), Measure('interior_facet', 0, {'ffc_representation': 'quadrature', 'quadrature_order': 4}))])";
  }

  /// Return the rank of the global tensor (r)
  virtual unsigned int rank() const
  {
    return 2;
  }

  /// Return the number of coefficients (n)
  virtual unsigned int num_coefficients() const
  {
    return 4;
  }

  /// Return the number of cell integrals
  virtual unsigned int num_cell_integrals() const
  {
    return 1;
  }
  
  /// Return the number of exterior facet integrals
  virtual unsigned int num_exterior_facet_integrals() const
  {
    return 0;
  }
  
  /// Return the number of interior facet integrals
  virtual unsigned int num_interior_facet_integrals() const
  {
    return 1;
  }
    
  /// Create a new finite element for argument function i
  virtual ufc::finite_element* create_finite_element(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_finite_element_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_finite_element_1();
      break;
    case 2:
      return new UFC_LPTcdgIBilinearForm_finite_element_2();
      break;
    case 3:
      return new UFC_LPTcdgIBilinearForm_finite_element_3();
      break;
    case 4:
      return new UFC_LPTcdgIBilinearForm_finite_element_4();
      break;
    case 5:
      return new UFC_LPTcdgIBilinearForm_finite_element_5();
      break;
    }
    return 0;
  }
  
  /// Create a new dof map for argument function i
  virtual ufc::dof_map* create_dof_map(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgIBilinearForm_dof_map_0();
      break;
    case 1:
      return new UFC_LPTcdgIBilinearForm_dof_map_1();
      break;
    case 2:
      return new UFC_LPTcdgIBilinearForm_dof_map_2();
      break;
    case 3:
      return new UFC_LPTcdgIBilinearForm_dof_map_3();
      break;
    case 4:
      return new UFC_LPTcdgIBilinearForm_dof_map_4();
      break;
    case 5:
      return new UFC_LPTcdgIBilinearForm_dof_map_5();
      break;
    }
    return 0;
  }

  /// Create a new cell integral on sub domain i
  virtual ufc::cell_integral* create_cell_integral(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_cell_integral_0();
  }

  /// Create a new exterior facet integral on sub domain i
  virtual ufc::exterior_facet_integral* create_exterior_facet_integral(unsigned int i) const
  {
    return 0;
  }

  /// Create a new interior facet integral on sub domain i
  virtual ufc::interior_facet_integral* create_interior_facet_integral(unsigned int i) const
  {
    return new UFC_LPTcdgIBilinearForm_interior_facet_integral_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_0_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_0_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_0_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_0_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_0_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_0_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_0_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_0_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "MixedElement([FiniteElement('Lagrange', 'triangle', 2), FiniteElement('Lagrange', 'triangle', 2)])";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 12;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 5)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
    }
    
    if (6 <= i && i <= 11)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 6;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 5)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {4.89897948556635, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0},
      {0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (6 <= i && i <= 11)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 6;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_2_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
      // Table(s) of coefficients
      const static double coefficients0[6][6] =   \
      {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
      {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
      {0, 0, 0.2, 0, 0, 0.163299316185545},
      {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
      {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
      {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {4.89897948556635, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0},
      {0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[6][6] =   \
      {{0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[12][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}, {{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[12][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[12][1][2] = {{{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[6];
    vertex_values[3] = dof_values[7];
    vertex_values[5] = dof_values[8];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgILinearForm_finite_element_0_0();
      break;
    case 1:
      return new UFC_LPTcdgILinearForm_finite_element_0_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_2: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_2()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_2();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_3: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_3() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_3()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_3();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_4: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_4() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_4()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 6;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_2_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    
    // Table(s) of coefficients
    const static double coefficients0[6][6] = \
    {{0, -0.173205080756888, -0.1, 0.121716123890037, 0.0942809041582064, 0.0544331053951817},
    {0, 0.173205080756888, -0.1, 0.121716123890037, -0.0942809041582063, 0.0544331053951818},
    {0, 0, 0.2, 0, 0, 0.163299316185545},
    {0.471404520791032, 0.23094010767585, 0.133333333333333, 0, 0.188561808316413, -0.163299316185545},
    {0.471404520791032, -0.23094010767585, 0.133333333333333, 0, -0.188561808316413, -0.163299316185545},
    {0.471404520791032, 0, -0.266666666666667, -0.243432247780074, 0, 0.0544331053951817}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {4.89897948556635, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0},
    {0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[6][6] = \
    {{0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175277, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[6][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.5, 0.5}}, {{0, 0.5}}, {{0.5, 0}}};
    const static double W[6][1] = {{1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[6][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_4();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_5_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_5_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_5_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_5_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_5_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_5_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_5_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_5_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_5: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_5() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_5()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "MixedElement([FiniteElement('Discontinuous Lagrange', 'triangle', 0), FiniteElement('Discontinuous Lagrange', 'triangle', 0)])";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 2;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 0)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0;
    }
    
    if (1 <= i && i <= 1)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 1;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 0)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[1][1] =   \
      {{0}};
    
      const static double dmats1[1][1] =   \
      {{0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (1 <= i && i <= 1)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 1;
    
      // Generate scalings
      const double scalings_y_0 = 1;
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
      // Table(s) of coefficients
      const static double coefficients0[1][1] =   \
      {{1.41421356237309}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[1][1] =   \
      {{0}};
    
      const static double dmats1[1][1] =   \
      {{0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[2][1][2] = {{{0.333333333333333, 0.333333333333333}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[2][1] = {{1}, {1}};
    const static double D[2][1][2] = {{{1, 0}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[0];
    vertex_values[4] = dof_values[0];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[1];
    vertex_values[3] = dof_values[1];
    vertex_values[5] = dof_values[1];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgILinearForm_finite_element_5_0();
      break;
    case 1:
      return new UFC_LPTcdgILinearForm_finite_element_5_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_6: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_6() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_6()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_6();
  }

};

/// This class defines the interface for a finite element.

class UFC_LPTcdgILinearForm_finite_element_7: public ufc::finite_element
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_finite_element_7() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_finite_element_7()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 1;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    
    // Table(s) of coefficients
    const static double coefficients0[1][1] = \
    {{1.41421356237309}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[1][1] = \
    {{0}};
    
    const static double dmats1[1][1] = \
    {{0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[1][1][2] = {{{0.333333333333333, 0.333333333333333}}};
    const static double W[1][1] = {{1}};
    const static double D[1][1][1] = {{{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[0];
    vertex_values[2] = dof_values[0];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_finite_element_7();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_0_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_0_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_0_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_0_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_0_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_0_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_0_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_0_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for MixedElement([FiniteElement('Lagrange', 'triangle', 2), FiniteElement('Lagrange', 'triangle', 2)])";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[0] + 2*m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 12;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 6;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
    offset = offset + m.num_entities[1];
    dofs[6] = offset + c.entity_indices[0][0];
    dofs[7] = offset + c.entity_indices[0][1];
    dofs[8] = offset + c.entity_indices[0][2];
    offset = offset + m.num_entities[0];
    dofs[9] = offset + c.entity_indices[1][0];
    dofs[10] = offset + c.entity_indices[1][1];
    dofs[11] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 7;
      dofs[4] = 8;
      dofs[5] = 9;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      dofs[3] = 6;
      dofs[4] = 8;
      dofs[5] = 10;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      dofs[3] = 6;
      dofs[4] = 7;
      dofs[5] = 11;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
    coordinates[6][0] = x[0][0];
    coordinates[6][1] = x[0][1];
    coordinates[7][0] = x[1][0];
    coordinates[7][1] = x[1][1];
    coordinates[8][0] = x[2][0];
    coordinates[8][1] = x[2][1];
    coordinates[9][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[9][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[10][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[10][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[11][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[11][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgILinearForm_dof_map_0_0();
      break;
    case 1:
      return new UFC_LPTcdgILinearForm_dof_map_0_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_2: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_2() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_2()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_2();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_3: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_3() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_3()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_3();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_4: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_4() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_4()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Lagrange', 'triangle', 2)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return false;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + m.num_entities[1];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 6;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 3;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + c.entity_indices[1][0];
    dofs[4] = offset + c.entity_indices[1][1];
    dofs[5] = offset + c.entity_indices[1][2];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 4;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 5;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.5*x[1][0] + 0.5*x[2][0];
    coordinates[3][1] = 0.5*x[1][1] + 0.5*x[2][1];
    coordinates[4][0] = 0.5*x[0][0] + 0.5*x[2][0];
    coordinates[4][1] = 0.5*x[0][1] + 0.5*x[2][1];
    coordinates[5][0] = 0.5*x[0][0] + 0.5*x[1][0];
    coordinates[5][1] = 0.5*x[0][1] + 0.5*x[1][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_4();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_5_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_5_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_5_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_5_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_5_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_5_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_5_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_5_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_5: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_5() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_5()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for MixedElement([FiniteElement('Discontinuous Lagrange', 'triangle', 0), FiniteElement('Discontinuous Lagrange', 'triangle', 0)])";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 2;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
    unsigned int offset = m.num_entities[2];
    dofs[1] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[1][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[1][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgILinearForm_dof_map_5_0();
      break;
    case 1:
      return new UFC_LPTcdgILinearForm_dof_map_5_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_6: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_6() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_6()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_6();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_LPTcdgILinearForm_dof_map_7: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_dof_map_7() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_dof_map_7()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for FiniteElement('Discontinuous Lagrange', 'triangle', 0)";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch (d)
    {
    case 0:
      return false;
      break;
    case 1:
      return false;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 1;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 0;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch (facet)
    {
    case 0:
      
      break;
    case 1:
      
      break;
    case 2:
      
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[0][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_dof_map_7();
  }

};

/// This class defines the interface for the tabulation of the cell
/// tensor corresponding to the local contribution to a form from
/// the integral over a cell.

class UFC_LPTcdgILinearForm_cell_integral_0_quadrature: public ufc::cell_integral
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_cell_integral_0_quadrature() : ufc::cell_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_cell_integral_0_quadrature()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local cell
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * x = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = x[1][0] - x[0][0];
    const double J_01 = x[2][0] - x[0][0];
    const double J_10 = x[1][1] - x[0][1];
    const double J_11 = x[2][1] - x[0][1];
      
    // Compute determinant of Jacobian
    double detJ = J_00*J_11 - J_01*J_10;
      
    // Compute inverse of Jacobian
    const double Jinv_00 =  J_11 / detJ;
    const double Jinv_01 = -J_01 / detJ;
    const double Jinv_10 = -J_10 / detJ;
    const double Jinv_11 =  J_00 / detJ;
    
    // Set scale factor
    const double det = std::abs(detJ);
    
    
    // Array of quadrature weights
    const static double W9[9] = {0.0558144204830443, 0.063678085099885, 0.0193963833059595, 0.0893030727728709, 0.101884936159816, 0.0310342132895351, 0.0558144204830443, 0.063678085099885, 0.0193963833059595};
    
    
    const static double FE0_D10[9][6] = \
    {{-2.23477754271068, -0.589129380761495, 0, 0.354351838050816, -0.354351838050816, 2.82390692347217},
    {-1.0959162708804, -0.733783728643342, 0, 1.63786745776294, -1.63786745776294, 1.82969999952374},
    {0.246362376191712, -0.904275470851677, 0, 3.15063784704339, -3.15063784704339, 0.657913094659966},
    {-0.822824080974592, 0.822824080974592, 0, 0.354351838050816, -0.354351838050816, 0},
    {-0.181066271118531, 0.181066271118531, 0, 1.63786745776294, -1.63786745776294, 0},
    {0.575318923521695, -0.575318923521694, 0, 3.15063784704339, -3.15063784704339, 0},
    {0.589129380761496, 2.23477754271068, 0, 0.354351838050816, -0.354351838050816, -2.82390692347218},
    {0.733783728643342, 1.0959162708804, 0, 1.63786745776294, -1.63786745776294, -1.82969999952374},
    {0.904275470851678, -0.246362376191711, 0, 3.15063784704339, -3.15063784704339, -0.657913094659967}};
    
    const static double FE0_D11[9][6] = \
    {{4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4},
    {3.99999999999999, 0, 0, 4, -4, -3.99999999999999},
    {4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4}};
    
    const static double FE0_D01[9][6] = \
    {{-2.23477754271068, 0, -0.645648161949184, 0.410870619238505, 2.88042570465986, -0.410870619238505},
    {-1.0959162708804, 0, 0.637867457762939, 0.266216271356658, 0.458048813117464, -0.266216271356658},
    {0.246362376191712, 0, 2.15063784704339, 0.0957245291483225, -2.3970002232351, -0.0957245291483228},
    {-0.822824080974592, 0, -0.645648161949184, 1.82282408097459, 1.46847224292378, -1.82282408097459},
    {-0.181066271118531, 0, 0.637867457762939, 1.18106627111853, -0.456801186644408, -1.18106627111853},
    {0.575318923521695, 0, 2.15063784704339, 0.424681076478306, -2.72595677056508, -0.424681076478306},
    {0.589129380761496, 0, -0.645648161949184, 3.23477754271068, 0.0565187811876886, -3.23477754271068},
    {0.733783728643342, 0, 0.637867457762939, 2.0959162708804, -1.37165118640628, -2.0959162708804},
    {0.904275470851678, 0, 2.15063784704339, 0.753637623808289, -3.05491331789507, -0.753637623808289}};
    
    const static double FE1_C1_D20[9][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -7.99999999999999},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 4, 0, 0, 0, -7.99999999999999},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, -8},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 4, 0, 0, 0, -7.99999999999999}};
    
    const static double FE0_D02[9][6] = \
    {{4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -7.99999999999999, 0},
    {4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0}};
    
    const static double FE1_C1[9][12] = \
    {{0, 0, 0, 0, 0, 0, 0.499278833175498, -0.0816158215904472, -0.072892306371455, 0.0363981897820603, 0.286562341986258, 0.332268763018086},
    {0, 0, 0, 0, 0, 0, 0.0251290590975511, -0.0576951799472843, -0.0741406382908807, 0.109006741895515, 0.858208263567716, 0.139491753677383},
    {0, 0, 0, 0, 0, 0, -0.117413197449647, -0.0227857341019971, 0.453155393641927, 0.0753983311062782, 0.593609805131561, 0.0180354016718772},
    {0, 0, 0, 0, 0, 0, -0.0403700664710398, -0.0403700664710398, -0.072892306371455, 0.161480265884159, 0.161480265884159, 0.830671907545217},
    {0, 0, 0, 0, 0, 0, -0.120901875682904, -0.120901875682904, -0.0741406382908807, 0.483607502731615, 0.483607502731615, 0.348729384193458},
    {0, 0, 0, 0, 0, 0, -0.0836260170297299, -0.0836260170297299, 0.453155393641927, 0.33450406811892, 0.33450406811892, 0.0450885041796932},
    {0, 0, 0, 0, 0, 0, -0.0816158215904472, 0.499278833175498, -0.072892306371455, 0.286562341986258, 0.0363981897820602, 0.332268763018086},
    {0, 0, 0, 0, 0, 0, -0.0576951799472843, 0.0251290590975512, -0.0741406382908807, 0.858208263567716, 0.109006741895515, 0.139491753677383},
    {0, 0, 0, 0, 0, 0, -0.0227857341019971, -0.117413197449647, 0.453155393641927, 0.593609805131561, 0.0753983311062784, 0.0180354016718773}};
    
    const static double FE1_C1_D02[9][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -7.99999999999999, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0},
    {0, 0, 0, 0, 0, 0, 4, 0, 4, 0, -8, 0}};
    
    const static double FE0_D20[9][6] = \
    {{4, 4, 0, 0, 0, -8},
    {4, 4, 0, 0, 0, -8},
    {4, 4, 0, 0, 0, -7.99999999999999},
    {4, 4, 0, 0, 0, -8},
    {4, 4, 0, 0, 0, -8},
    {3.99999999999999, 4, 0, 0, 0, -7.99999999999999},
    {4, 4, 0, 0, 0, -8},
    {4, 4, 0, 0, 0, -8},
    {3.99999999999999, 4, 0, 0, 0, -7.99999999999999}};
    
    const static double FE1_C1_D11[9][12] = \
    {{0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 3.99999999999999, 0, 0, 4, -4, -3.99999999999999},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4},
    {0, 0, 0, 0, 0, 0, 4, 0, 0, 4, -4, -4}};
    
    const static double FE0[9][6] = \
    {{0.499278833175498, -0.0816158215904472, -0.072892306371455, 0.0363981897820603, 0.286562341986258, 0.332268763018086},
    {0.0251290590975511, -0.0576951799472843, -0.0741406382908807, 0.109006741895515, 0.858208263567716, 0.139491753677383},
    {-0.117413197449647, -0.0227857341019971, 0.453155393641927, 0.0753983311062782, 0.593609805131561, 0.0180354016718772},
    {-0.0403700664710398, -0.0403700664710398, -0.072892306371455, 0.161480265884159, 0.161480265884159, 0.830671907545217},
    {-0.120901875682904, -0.120901875682904, -0.0741406382908807, 0.483607502731615, 0.483607502731615, 0.348729384193458},
    {-0.0836260170297299, -0.0836260170297299, 0.453155393641927, 0.33450406811892, 0.33450406811892, 0.0450885041796932},
    {-0.0816158215904472, 0.499278833175498, -0.072892306371455, 0.286562341986258, 0.0363981897820602, 0.332268763018086},
    {-0.0576951799472843, 0.0251290590975512, -0.0741406382908807, 0.858208263567716, 0.109006741895515, 0.139491753677383},
    {-0.0227857341019971, -0.117413197449647, 0.453155393641927, 0.593609805131561, 0.0753983311062784, 0.0180354016718773}};
    
    const static double FE1_C0_D01[9][12] = \
    {{-2.23477754271068, 0, -0.645648161949184, 0.410870619238505, 2.88042570465986, -0.410870619238505, 0, 0, 0, 0, 0, 0},
    {-1.0959162708804, 0, 0.637867457762939, 0.266216271356658, 0.458048813117464, -0.266216271356658, 0, 0, 0, 0, 0, 0},
    {0.246362376191712, 0, 2.15063784704339, 0.0957245291483225, -2.3970002232351, -0.0957245291483228, 0, 0, 0, 0, 0, 0},
    {-0.822824080974592, 0, -0.645648161949184, 1.82282408097459, 1.46847224292378, -1.82282408097459, 0, 0, 0, 0, 0, 0},
    {-0.181066271118531, 0, 0.637867457762939, 1.18106627111853, -0.456801186644408, -1.18106627111853, 0, 0, 0, 0, 0, 0},
    {0.575318923521695, 0, 2.15063784704339, 0.424681076478306, -2.72595677056508, -0.424681076478306, 0, 0, 0, 0, 0, 0},
    {0.589129380761496, 0, -0.645648161949184, 3.23477754271068, 0.0565187811876886, -3.23477754271068, 0, 0, 0, 0, 0, 0},
    {0.733783728643342, 0, 0.637867457762939, 2.0959162708804, -1.37165118640628, -2.0959162708804, 0, 0, 0, 0, 0, 0},
    {0.904275470851678, 0, 2.15063784704339, 0.753637623808289, -3.05491331789507, -0.753637623808289, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_C0_D10[9][12] = \
    {{-2.23477754271068, -0.589129380761495, 0, 0.354351838050816, -0.354351838050816, 2.82390692347217, 0, 0, 0, 0, 0, 0},
    {-1.0959162708804, -0.733783728643342, 0, 1.63786745776294, -1.63786745776294, 1.82969999952374, 0, 0, 0, 0, 0, 0},
    {0.246362376191712, -0.904275470851677, 0, 3.15063784704339, -3.15063784704339, 0.657913094659966, 0, 0, 0, 0, 0, 0},
    {-0.822824080974592, 0.822824080974592, 0, 0.354351838050816, -0.354351838050816, 0, 0, 0, 0, 0, 0, 0},
    {-0.181066271118531, 0.181066271118531, 0, 1.63786745776294, -1.63786745776294, 0, 0, 0, 0, 0, 0, 0},
    {0.575318923521695, -0.575318923521694, 0, 3.15063784704339, -3.15063784704339, 0, 0, 0, 0, 0, 0, 0},
    {0.589129380761496, 2.23477754271068, 0, 0.354351838050816, -0.354351838050816, -2.82390692347218, 0, 0, 0, 0, 0, 0},
    {0.733783728643342, 1.0959162708804, 0, 1.63786745776294, -1.63786745776294, -1.82969999952374, 0, 0, 0, 0, 0, 0},
    {0.904275470851678, -0.246362376191711, 0, 3.15063784704339, -3.15063784704339, -0.657913094659967, 0, 0, 0, 0, 0, 0}};
    
    // Compute element tensor using UFL quadrature representation
    // Optimisations: ('simplify expressions', False), ('ignore zero tables', False), ('non zero columns', False), ('remove zero terms', False), ('ignore ones', False)
    // Total number of operations to compute element tensor: 11016
    
    // Loop quadrature points for integral
    // Number of operations to compute element tensor for following IP loop = 11016
    for (unsigned int ip = 0; ip < 9; ip++)
    {
      
      // Function declarations
      double F0 = 0;
      double F1 = 0;
      double F2 = 0;
      double F3 = 0;
      double F4 = 0;
      double F5 = 0;
      double F6 = 0;
      double F7 = 0;
      
      // Total number of operations to compute function values = 96
      for (unsigned int r = 0; r < 6; r++)
      {
        F0 += FE0_D10[ip][r]*w[2][r];
        F1 += FE0_D01[ip][r]*w[2][r];
        F2 += FE0[ip][r]*w[1][r];
        F3 += FE0[ip][r]*w[3][r];
        F4 += FE0[ip][r]*w[0][r];
        F5 += FE0_D20[ip][r]*w[2][r];
        F6 += FE0_D11[ip][r]*w[2][r];
        F7 += FE0_D02[ip][r]*w[2][r];
      }// end loop over 'r'
      
      // Number of operations for primary indices = 1128
      for (unsigned int j = 0; j < 12; j++)
      {
        // Number of operations to compute entry = 94
        A[j] += (FE1_C1[ip][j]*-0.5*((Jinv_00*F0 + Jinv_10*F1)*(Jinv_00*F0 + Jinv_10*F1) + (Jinv_01*F0 + Jinv_11*F1)*(Jinv_01*F0 + Jinv_11*F1)) + (FE1_C1[ip][j]*F2*-1*F3 + (((Jinv_00*Jinv_00*FE1_C1_D20[ip][j] + Jinv_00*Jinv_10*FE1_C1_D11[ip][j] + Jinv_10*Jinv_00*FE1_C1_D11[ip][j] + Jinv_10*Jinv_10*FE1_C1_D02[ip][j]) + (Jinv_01*Jinv_01*FE1_C1_D20[ip][j] + Jinv_01*Jinv_11*FE1_C1_D11[ip][j] + Jinv_11*Jinv_01*FE1_C1_D11[ip][j] + Jinv_11*Jinv_11*FE1_C1_D02[ip][j]))*F4*F4*0.0833333333333334*F4*((Jinv_00*Jinv_00*F5 + Jinv_00*Jinv_10*F6 + Jinv_10*Jinv_00*F6 + Jinv_10*Jinv_10*F7) + (Jinv_01*Jinv_01*F5 + Jinv_01*Jinv_11*F6 + Jinv_11*Jinv_01*F6 + Jinv_11*Jinv_11*F7)) + ((Jinv_00*FE1_C0_D10[ip][j] + Jinv_10*FE1_C0_D01[ip][j])*(Jinv_00*F0 + Jinv_10*F1) + (Jinv_01*FE1_C0_D10[ip][j] + Jinv_11*FE1_C0_D01[ip][j])*(Jinv_01*F0 + Jinv_11*F1))*(F4 + F2))))*W9[ip]*det;
      }// end loop over 'j'
    }// end loop over 'ip'
  }

};

/// This class defines the interface for the tabulation of the cell
/// tensor corresponding to the local contribution to a form from
/// the integral over a cell.

class UFC_LPTcdgILinearForm_cell_integral_0: public ufc::cell_integral
{
private:

  UFC_LPTcdgILinearForm_cell_integral_0_quadrature integral_0_quadrature;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_cell_integral_0() : ufc::cell_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_cell_integral_0()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local cell
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c) const
  {
    // Reset values of the element tensor block
    A[0] = 0;
    A[1] = 0;
    A[2] = 0;
    A[3] = 0;
    A[4] = 0;
    A[5] = 0;
    A[6] = 0;
    A[7] = 0;
    A[8] = 0;
    A[9] = 0;
    A[10] = 0;
    A[11] = 0;
    
    // Add all contributions to element tensor
    integral_0_quadrature.tabulate_tensor(A, w, c);
  }

};

/// This class defines the interface for the tabulation of the
/// interior facet tensor corresponding to the local contribution to
/// a form from the integral over an interior facet.

class UFC_LPTcdgILinearForm_interior_facet_integral_0_quadrature: public ufc::interior_facet_integral
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm_interior_facet_integral_0_quadrature() : ufc::interior_facet_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_interior_facet_integral_0_quadrature()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local interior facet
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c0,
                               const ufc::cell& c1,
                               unsigned int facet0,
                               unsigned int facet1) const
  {
    // Extract vertex coordinates
    const double * const * x0 = c0.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J0_00 = x0[1][0] - x0[0][0];
    const double J0_01 = x0[2][0] - x0[0][0];
    const double J0_10 = x0[1][1] - x0[0][1];
    const double J0_11 = x0[2][1] - x0[0][1];
      
    // Compute determinant of Jacobian
    double detJ0 = J0_00*J0_11 - J0_01*J0_10;
      
    // Compute inverse of Jacobian
    const double Jinv0_00 =  J0_11 / detJ0;
    const double Jinv0_01 = -J0_01 / detJ0;
    const double Jinv0_10 = -J0_10 / detJ0;
    const double Jinv0_11 =  J0_00 / detJ0;
    
    // Extract vertex coordinates
    const double * const * x1 = c1.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J1_00 = x1[1][0] - x1[0][0];
    const double J1_01 = x1[2][0] - x1[0][0];
    const double J1_10 = x1[1][1] - x1[0][1];
    const double J1_11 = x1[2][1] - x1[0][1];
      
    // Compute determinant of Jacobian
    double detJ1 = J1_00*J1_11 - J1_01*J1_10;
      
    // Compute inverse of Jacobian
    const double Jinv1_00 =  J1_11 / detJ1;
    const double Jinv1_01 = -J1_01 / detJ1;
    const double Jinv1_10 = -J1_10 / detJ1;
    const double Jinv1_11 =  J1_00 / detJ1;
    
    // Vertices on edges
    static unsigned int edge_vertices[3][2] = {{1, 2}, {0, 2}, {0, 1}};
    
    // Get vertices
    const unsigned int v0 = edge_vertices[facet0][0];
    const unsigned int v1 = edge_vertices[facet0][1];
    
    // Compute scale factor (length of edge scaled by length of reference interval)
    const double dx0 = x0[v1][0] - x0[v0][0];
    const double dx1 = x0[v1][1] - x0[v0][1];
    const double det = std::sqrt(dx0*dx0 + dx1*dx1);
    
    
    // Array of quadrature weights
    const static double W3[3] = {0.277777777777778, 0.444444444444444, 0.277777777777778};
    
    
    const static double FE1_f1_C0_D11[3][12] = \
    {{4, 0, 0, 4, -4, -4, 0, 0, 0, 0, 0, 0},
    {4, 0, 0, 4, -4, -4, 0, 0, 0, 0, 0, 0},
    {4, 0, 0, 4, -4, -4, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f1_C0_D10[3][12] = \
    {{-2.54919333848297, -1, 0, 0.450806661517033, -0.450806661517033, 3.54919333848297, 0, 0, 0, 0, 0, 0},
    {-0.999999999999999, -1, 0, 2, -2, 2, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, -1, 0, 3.54919333848297, -3.54919333848297, 0.450806661517032, 0, 0, 0, 0, 0, 0}};
    
    const static double FE0_f2[3][6] = \
    {{0.687298334620742, -0.0872983346207417, 0, 0, 0, 0.4},
    {0, 0, 0, 0, 0, 1},
    {-0.0872983346207417, 0.687298334620742, 0, 0, 0, 0.4}};
    
    const static double FE1_f0_C1_D01[3][12] = \
    {{0, 0, 0, 0, 0, 0, 1, 0, -0.549193338482967, 3.54919333848297, -0.450806661517033, -3.54919333848297},
    {0, 0, 0, 0, 0, 0, 1, 0, 1, 2, -2, -2},
    {0, 0, 0, 0, 0, 0, 1, 0, 2.54919333848297, 0.450806661517033, -3.54919333848297, -0.450806661517033}};
    
    const static double FE1_f2_C1_D01[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, 0, -1, 0.450806661517034, 3.54919333848297, -0.450806661517033},
    {0, 0, 0, 0, 0, 0, -0.999999999999999, 0, -1, 2, 2, -2},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, 0, -1, 3.54919333848297, 0.450806661517032, -3.54919333848297}};
    
    const static double FE1_f1_C1_D10[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, -1, 0, 0.450806661517033, -0.450806661517033, 3.54919333848297},
    {0, 0, 0, 0, 0, 0, -0.999999999999999, -1, 0, 2, -2, 2},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, -1, 0, 3.54919333848297, -3.54919333848297, 0.450806661517032}};
    
    const static double FE0_f1_D11[3][6] = \
    {{4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4}};
    
    const static double FE0_f1_D10[3][6] = \
    {{-2.54919333848297, -1, 0, 0.450806661517033, -0.450806661517033, 3.54919333848297},
    {-0.999999999999999, -1, 0, 2, -2, 2},
    {0.549193338482968, -1, 0, 3.54919333848297, -3.54919333848297, 0.450806661517032}};
    
    const static double FE0_f2_D10[3][6] = \
    {{-2.54919333848297, -0.549193338482967, 0, 0, 0, 3.09838667696593},
    {-1, 1, 0, 0, 0, 0},
    {0.549193338482968, 2.54919333848297, 0, 0, 0, -3.09838667696594}};
    
    const static double FE0_f2_D11[3][6] = \
    {{4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4},
    {3.99999999999999, 0, 0, 4, -4, -3.99999999999999}};
    
    const static double FE0_f0[3][6] = \
    {{0, 0.687298334620742, -0.0872983346207417, 0.4, 0, 0},
    {0, 0, 0, 1, 0, 0},
    {0, -0.0872983346207416, 0.687298334620742, 0.4, 0, 0}};
    
    const static double FE1_f2_C0_D02[3][12] = \
    {{4, 0, 4, 0, -7.99999999999999, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 4, 0, -7.99999999999999, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 4, 0, -7.99999999999999, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f2_C0_D01[3][12] = \
    {{-2.54919333848297, 0, -1, 0.450806661517034, 3.54919333848297, -0.450806661517033, 0, 0, 0, 0, 0, 0},
    {-0.999999999999999, 0, -1, 2, 2, -2, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, 0, -1, 3.54919333848297, 0.450806661517032, -3.54919333848297, 0, 0, 0, 0, 0, 0}};
    
    const static double FE0_f1[3][6] = \
    {{0.687298334620742, 0, -0.0872983346207417, 0, 0.4, 0},
    {0, 0, 0, 0, 1, 0},
    {-0.0872983346207417, 0, 0.687298334620742, 0, 0.4, 0}};
    
    const static double FE1_f2_C0_D20[3][12] = \
    {{4, 4, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0},
    {4, 4, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0},
    {4, 4, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0}};
    
    const static double FE0_f0_D10[3][6] = \
    {{1, 2.54919333848297, 0, 0.450806661517033, -0.450806661517033, -3.54919333848297},
    {1, 1, 0, 2, -2, -2},
    {1, -0.549193338482967, 0, 3.54919333848297, -3.54919333848297, -0.450806661517034}};
    
    const static double FE0_f0_D11[3][6] = \
    {{3.99999999999999, 0, 0, 4, -4, -3.99999999999999},
    {4, 0, 0, 4, -4, -4},
    {4, 0, 0, 4, -4, -4}};
    
    const static double FE1_f1_C0_D20[3][12] = \
    {{4, 4, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0},
    {4, 4, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0},
    {3.99999999999999, 4, 0, 0, 0, -7.99999999999999, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f0_C0_D10[3][12] = \
    {{1, 2.54919333848297, 0, 0.450806661517033, -0.450806661517033, -3.54919333848297, 0, 0, 0, 0, 0, 0},
    {1, 1, 0, 2, -2, -2, 0, 0, 0, 0, 0, 0},
    {1, -0.549193338482967, 0, 3.54919333848297, -3.54919333848297, -0.450806661517034, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f0_C0_D11[3][12] = \
    {{3.99999999999999, 0, 0, 4, -4, -3.99999999999999, 0, 0, 0, 0, 0, 0},
    {4, 0, 0, 4, -4, -4, 0, 0, 0, 0, 0, 0},
    {4, 0, 0, 4, -4, -4, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f1_C0_D02[3][12] = \
    {{4, 0, 4, 0, -8, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 4, 0, -8, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 4, 0, -8, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f1_C0_D01[3][12] = \
    {{-2.54919333848297, 0, -0.549193338482967, 0, 3.09838667696593, 0, 0, 0, 0, 0, 0, 0},
    {-1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, 0, 2.54919333848297, 0, -3.09838667696594, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double FE0_f2_D02[3][6] = \
    {{4, 0, 4, 0, -7.99999999999999, 0},
    {4, 0, 4, 0, -7.99999999999999, 0},
    {4, 0, 4, 0, -7.99999999999999, 0}};
    
    const static double FE0_f2_D01[3][6] = \
    {{-2.54919333848297, 0, -1, 0.450806661517034, 3.54919333848297, -0.450806661517033},
    {-0.999999999999999, 0, -1, 2, 2, -2},
    {0.549193338482968, 0, -1, 3.54919333848297, 0.450806661517032, -3.54919333848297}};
    
    const static double FE1_f2_C1_D10[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, -0.549193338482967, 0, 0, 0, 3.09838667696593},
    {0, 0, 0, 0, 0, 0, -1, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, 2.54919333848297, 0, 0, 0, -3.09838667696594}};
    
    const static double FE0_f2_D20[3][6] = \
    {{4, 4, 0, 0, 0, -8},
    {4, 4, 0, 0, 0, -8},
    {4, 4, 0, 0, 0, -8}};
    
    const static double FE1_f0_C1_D10[3][12] = \
    {{0, 0, 0, 0, 0, 0, 1, 2.54919333848297, 0, 0.450806661517033, -0.450806661517033, -3.54919333848297},
    {0, 0, 0, 0, 0, 0, 1, 1, 0, 2, -2, -2},
    {0, 0, 0, 0, 0, 0, 1, -0.549193338482967, 0, 3.54919333848297, -3.54919333848297, -0.450806661517034}};
    
    const static double FE1_f1_C1_D01[3][12] = \
    {{0, 0, 0, 0, 0, 0, -2.54919333848297, 0, -0.549193338482967, 0, 3.09838667696593, 0},
    {0, 0, 0, 0, 0, 0, -1, 0, 1, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0.549193338482968, 0, 2.54919333848297, 0, -3.09838667696594, 0}};
    
    const static double FE1_f2_C0_D10[3][12] = \
    {{-2.54919333848297, -0.549193338482967, 0, 0, 0, 3.09838667696593, 0, 0, 0, 0, 0, 0},
    {-1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0.549193338482968, 2.54919333848297, 0, 0, 0, -3.09838667696594, 0, 0, 0, 0, 0, 0}};
    
    const static double FE1_f2_C0_D11[3][12] = \
    {{4, 0, 0, 4, -4, -4, 0, 0, 0, 0, 0, 0},
    {4, 0, 0, 4, -4, -4, 0, 0, 0, 0, 0, 0},
    {3.99999999999999, 0, 0, 4, -4, -3.99999999999999, 0, 0, 0, 0, 0, 0}};
    
    const static double FE0_f1_D20[3][6] = \
    {{4, 4, 0, 0, 0, -8},
    {4, 4, 0, 0, 0, -8},
    {3.99999999999999, 4, 0, 0, 0, -7.99999999999999}};
    
    const static double FE0_f1_D01[3][6] = \
    {{-2.54919333848297, 0, -0.549193338482967, 0, 3.09838667696593, 0},
    {-1, 0, 1, 0, 0, 0},
    {0.549193338482968, 0, 2.54919333848297, 0, -3.09838667696594, 0}};
    
    const static double FE0_f1_D02[3][6] = \
    {{4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0},
    {4, 0, 4, 0, -8, 0}};
    
    const static double FE0_f0_D01[3][6] = \
    {{1, 0, -0.549193338482967, 3.54919333848297, -0.450806661517033, -3.54919333848297},
    {1, 0, 1, 2, -2, -2},
    {1, 0, 2.54919333848297, 0.450806661517033, -3.54919333848297, -0.450806661517033}};
    
    const static double FE1_f0_C0_D01[3][12] = \
    {{1, 0, -0.549193338482967, 3.54919333848297, -0.450806661517033, -3.54919333848297, 0, 0, 0, 0, 0, 0},
    {1, 0, 1, 2, -2, -2, 0, 0, 0, 0, 0, 0},
    {1, 0, 2.54919333848297, 0.450806661517033, -3.54919333848297, -0.450806661517033, 0, 0, 0, 0, 0, 0}};
    
    // Compute element tensor using UFL quadrature representation
    // Optimisations: ('simplify expressions', False), ('ignore zero tables', False), ('non zero columns', False), ('remove zero terms', False), ('ignore ones', False)
    switch ( facet0 )
    {
    case 0:
      switch ( facet1 )
      {
      case 0:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f0_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f0_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f0_D10[ip][r]*w[2][r];
            F3 += FE0_f0_D01[ip][r]*w[2][r];
            F4 += FE0_f0_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f0_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f0_D10[ip][r]*w[1][r];
            F7 += FE0_f0_D01[ip][r]*w[1][r];
            F8 += FE0_f1_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f0_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f1_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f1_D20[ip][r]*w[2][r];
            F12 += FE0_f0_D11[ip][r]*w[2][r];
            F13 += FE0_f1_D02[ip][r]*w[2][r];
            F14 += FE0_f0[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f1_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f1_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f1_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f1_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f1_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f1_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 1:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f1_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f1_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f0_D10[ip][r]*w[2][r];
            F3 += FE0_f0_D01[ip][r]*w[2][r];
            F4 += FE0_f1_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f1_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f0_D10[ip][r]*w[1][r];
            F7 += FE0_f0_D01[ip][r]*w[1][r];
            F8 += FE0_f1_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f1_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f1_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f1_D20[ip][r]*w[2][r];
            F12 += FE0_f0_D11[ip][r]*w[2][r];
            F13 += FE0_f1_D02[ip][r]*w[2][r];
            F14 += FE0_f0[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f1_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f1_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f1_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f1_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f1_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f1_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 2:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f2_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f2_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f0_D10[ip][r]*w[2][r];
            F3 += FE0_f0_D01[ip][r]*w[2][r];
            F4 += FE0_f2_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f2_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f0_D10[ip][r]*w[1][r];
            F7 += FE0_f0_D01[ip][r]*w[1][r];
            F8 += FE0_f2_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f2_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f2_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f1_D20[ip][r]*w[2][r];
            F12 += FE0_f0_D11[ip][r]*w[2][r];
            F13 += FE0_f1_D02[ip][r]*w[2][r];
            F14 += FE0_f0[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f0_C1_D10[ip][j] + Jinv0_10*FE1_f0_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C1_D10[ip][j] + Jinv0_11*FE1_f0_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f0_C0_D10[ip][j] + Jinv0_10*FE1_f0_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f0_C0_D10[ip][j] + Jinv0_11*FE1_f0_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f1_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f0_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f0_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f1_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f1_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f0_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f0_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f2_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      }
      break;
    case 1:
      switch ( facet1 )
      {
      case 0:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f0_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f0_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f1_D10[ip][r]*w[2][r];
            F3 += FE0_f1_D01[ip][r]*w[2][r];
            F4 += FE0_f0_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f0_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f1_D10[ip][r]*w[1][r];
            F7 += FE0_f1_D01[ip][r]*w[1][r];
            F8 += FE0_f1_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f0_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f1_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f1_D20[ip][r]*w[2][r];
            F12 += FE0_f1_D11[ip][r]*w[2][r];
            F13 += FE0_f1_D02[ip][r]*w[2][r];
            F14 += FE0_f1[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f1_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f1_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f1_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f1_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f1_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f1_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 1:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f1_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f1_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f1_D10[ip][r]*w[2][r];
            F3 += FE0_f1_D01[ip][r]*w[2][r];
            F4 += FE0_f1_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f1_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f1_D10[ip][r]*w[1][r];
            F7 += FE0_f1_D01[ip][r]*w[1][r];
            F8 += FE0_f1_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f1_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f1_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f1_D20[ip][r]*w[2][r];
            F12 += FE0_f1_D11[ip][r]*w[2][r];
            F13 += FE0_f1_D02[ip][r]*w[2][r];
            F14 += FE0_f1[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f1_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f1_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f1_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f1_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f1_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f1_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 2:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f2_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f2_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f1_D10[ip][r]*w[2][r];
            F3 += FE0_f1_D01[ip][r]*w[2][r];
            F4 += FE0_f2_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f2_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f1_D10[ip][r]*w[1][r];
            F7 += FE0_f1_D01[ip][r]*w[1][r];
            F8 += FE0_f2_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f2_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f2_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f1_D20[ip][r]*w[2][r];
            F12 += FE0_f1_D11[ip][r]*w[2][r];
            F13 += FE0_f1_D02[ip][r]*w[2][r];
            F14 += FE0_f1[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f1_C1_D10[ip][j] + Jinv0_10*FE1_f1_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C1_D10[ip][j] + Jinv0_11*FE1_f1_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f1_C0_D10[ip][j] + Jinv0_10*FE1_f1_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f1_C0_D10[ip][j] + Jinv0_11*FE1_f1_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f1_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f1_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f1_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f1_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f1_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f1_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f1_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f2_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      }
      break;
    case 2:
      switch ( facet1 )
      {
      case 0:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f0_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f0_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f2_D10[ip][r]*w[2][r];
            F3 += FE0_f2_D01[ip][r]*w[2][r];
            F4 += FE0_f0_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f0_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f2_D10[ip][r]*w[1][r];
            F7 += FE0_f2_D01[ip][r]*w[1][r];
            F8 += FE0_f1_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f0_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f1_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f2_D20[ip][r]*w[2][r];
            F12 += FE0_f2_D11[ip][r]*w[2][r];
            F13 += FE0_f2_D02[ip][r]*w[2][r];
            F14 += FE0_f2[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f2_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f0_C1_D10[ip][j] + Jinv1_10*FE1_f0_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C1_D10[ip][j] + Jinv1_11*FE1_f0_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f0_C0_D10[ip][j] + Jinv1_10*FE1_f0_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f0_C0_D10[ip][j] + Jinv1_11*FE1_f0_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f1_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f0_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f0_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f1_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f1_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f0_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f0_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 1:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f1_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f1_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f2_D10[ip][r]*w[2][r];
            F3 += FE0_f2_D01[ip][r]*w[2][r];
            F4 += FE0_f1_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f1_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f2_D10[ip][r]*w[1][r];
            F7 += FE0_f2_D01[ip][r]*w[1][r];
            F8 += FE0_f1_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f1_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f1_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f2_D20[ip][r]*w[2][r];
            F12 += FE0_f2_D11[ip][r]*w[2][r];
            F13 += FE0_f2_D02[ip][r]*w[2][r];
            F14 += FE0_f2[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f2_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f1_C1_D10[ip][j] + Jinv1_10*FE1_f1_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C1_D10[ip][j] + Jinv1_11*FE1_f1_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f1_C0_D10[ip][j] + Jinv1_10*FE1_f1_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f1_C0_D10[ip][j] + Jinv1_11*FE1_f1_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f1_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f1_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f1_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f1_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f1_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f1_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f1_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f1_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      case 2:
        {
        // Total number of operations to compute element tensor (from this point): 13212
        
        // Loop quadrature points for integral
        // Number of operations to compute element tensor for following IP loop = 13212
        for (unsigned int ip = 0; ip < 3; ip++)
        {
          
          // Function declarations
          double F0 = 0;
          double F1 = 0;
          double F2 = 0;
          double F3 = 0;
          double F4 = 0;
          double F5 = 0;
          double F6 = 0;
          double F7 = 0;
          double F8 = 0;
          double F9 = 0;
          double F10 = 0;
          double F11 = 0;
          double F12 = 0;
          double F13 = 0;
          double F14 = 0;
          
          // Total number of operations to compute function values = 180
          for (unsigned int r = 0; r < 6; r++)
          {
            F0 += FE0_f2_D10[ip][r]*w[2][r + 6];
            F1 += FE0_f2_D01[ip][r]*w[2][r + 6];
            F2 += FE0_f2_D10[ip][r]*w[2][r];
            F3 += FE0_f2_D01[ip][r]*w[2][r];
            F4 += FE0_f2_D10[ip][r]*w[1][r + 6];
            F5 += FE0_f2_D01[ip][r]*w[1][r + 6];
            F6 += FE0_f2_D10[ip][r]*w[1][r];
            F7 += FE0_f2_D01[ip][r]*w[1][r];
            F8 += FE0_f2_D20[ip][r]*w[2][r + 6];
            F9 += FE0_f2_D11[ip][r]*w[2][r + 6];
            F10 += FE0_f2_D02[ip][r]*w[2][r + 6];
            F11 += FE0_f2_D20[ip][r]*w[2][r];
            F12 += FE0_f2_D11[ip][r]*w[2][r];
            F13 += FE0_f2_D02[ip][r]*w[2][r];
            F14 += FE0_f2[ip][r]*w[0][r];
          }// end loop over 'r'
          
          // Number of operations for primary indices = 4224
          for (unsigned int j = 0; j < 12; j++)
          {
            // Number of operations to compute entry = 176
            A[j] += (((Jinv0_00*FE1_f2_C1_D10[ip][j] + Jinv0_10*FE1_f2_C1_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C1_D10[ip][j] + Jinv0_11*FE1_f2_C1_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[4][1])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv0_00*FE1_f2_C0_D10[ip][j] + Jinv0_10*FE1_f2_C0_D01[ip][j])*w[4][0] + (Jinv0_01*FE1_f2_C0_D10[ip][j] + Jinv0_11*FE1_f2_C0_D01[ip][j])*w[4][1])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv0_00*Jinv0_00*FE1_f2_C0_D20[ip][j] + Jinv0_00*Jinv0_10*FE1_f2_C0_D11[ip][j] + Jinv0_10*Jinv0_00*FE1_f2_C0_D11[ip][j] + Jinv0_10*Jinv0_10*FE1_f2_C0_D02[ip][j]) + (Jinv0_01*Jinv0_01*FE1_f2_C0_D20[ip][j] + Jinv0_01*Jinv0_11*FE1_f2_C0_D11[ip][j] + Jinv0_11*Jinv0_01*FE1_f2_C0_D11[ip][j] + Jinv0_11*Jinv0_11*FE1_f2_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
            // Number of operations to compute entry = 176
            A[(j + 12)] += (((Jinv1_00*FE1_f2_C1_D10[ip][j] + Jinv1_10*FE1_f2_C1_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C1_D10[ip][j] + Jinv1_11*FE1_f2_C1_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[4][3])*((w[4][2]*(Jinv1_00*F4 + Jinv1_10*F5) + w[4][3]*(Jinv1_01*F4 + Jinv1_11*F5)) + (w[4][0]*(Jinv0_00*F6 + Jinv0_10*F7) + w[4][1]*(Jinv0_01*F6 + Jinv0_11*F7)))*w[5][0]/(w[6][0]) + (((Jinv1_00*FE1_f2_C0_D10[ip][j] + Jinv1_10*FE1_f2_C0_D01[ip][j])*w[4][2] + (Jinv1_01*FE1_f2_C0_D10[ip][j] + Jinv1_11*FE1_f2_C0_D01[ip][j])*w[4][3])*0.5*(((Jinv1_00*Jinv1_00*F8 + Jinv1_00*Jinv1_10*F9 + Jinv1_10*Jinv1_00*F9 + Jinv1_10*Jinv1_10*F10) + (Jinv1_01*Jinv1_01*F8 + Jinv1_01*Jinv1_11*F9 + Jinv1_11*Jinv1_01*F9 + Jinv1_11*Jinv1_11*F10)) + ((Jinv0_00*Jinv0_00*F11 + Jinv0_00*Jinv0_10*F12 + Jinv0_10*Jinv0_00*F12 + Jinv0_10*Jinv0_10*F13) + (Jinv0_01*Jinv0_01*F11 + Jinv0_01*Jinv0_11*F12 + Jinv0_11*Jinv0_01*F12 + Jinv0_11*Jinv0_11*F13)))*F14*F14*-0.0833333333333334*F14 + ((Jinv1_00*Jinv1_00*FE1_f2_C0_D20[ip][j] + Jinv1_00*Jinv1_10*FE1_f2_C0_D11[ip][j] + Jinv1_10*Jinv1_00*FE1_f2_C0_D11[ip][j] + Jinv1_10*Jinv1_10*FE1_f2_C0_D02[ip][j]) + (Jinv1_01*Jinv1_01*FE1_f2_C0_D20[ip][j] + Jinv1_01*Jinv1_11*FE1_f2_C0_D11[ip][j] + Jinv1_11*Jinv1_01*FE1_f2_C0_D11[ip][j] + Jinv1_11*Jinv1_11*FE1_f2_C0_D02[ip][j]))*0.5*F14*F14*-0.0833333333333334*F14*((w[4][2]*(Jinv1_00*F0 + Jinv1_10*F1) + w[4][3]*(Jinv1_01*F0 + Jinv1_11*F1)) + (w[4][0]*(Jinv0_00*F2 + Jinv0_10*F3) + w[4][1]*(Jinv0_01*F2 + Jinv0_11*F3))))))*W3[ip]*det;
          }// end loop over 'j'
        }// end loop over 'ip'
        }
        break;
      }
      break;
    }
  }

};

/// This class defines the interface for the tabulation of the
/// interior facet tensor corresponding to the local contribution to
/// a form from the integral over an interior facet.

class UFC_LPTcdgILinearForm_interior_facet_integral_0: public ufc::interior_facet_integral
{
private:

  UFC_LPTcdgILinearForm_interior_facet_integral_0_quadrature integral_0_quadrature;

public:

  /// Constructor
  UFC_LPTcdgILinearForm_interior_facet_integral_0() : ufc::interior_facet_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm_interior_facet_integral_0()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local interior facet
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c0,
                               const ufc::cell& c1,
                               unsigned int facet0,
                               unsigned int facet1) const
  {
    // Reset values of the element tensor block
    A[0] = 0;
    A[1] = 0;
    A[2] = 0;
    A[3] = 0;
    A[4] = 0;
    A[5] = 0;
    A[6] = 0;
    A[7] = 0;
    A[8] = 0;
    A[9] = 0;
    A[10] = 0;
    A[11] = 0;
    A[12] = 0;
    A[13] = 0;
    A[14] = 0;
    A[15] = 0;
    A[16] = 0;
    A[17] = 0;
    A[18] = 0;
    A[19] = 0;
    A[20] = 0;
    A[21] = 0;
    A[22] = 0;
    A[23] = 0;
    
    // Add all contributions to element tensor
    integral_0_quadrature.tabulate_tensor(A, w, c0, c1, facet0, facet1);
  }

};

/// This class defines the interface for the assembly of the global
/// tensor corresponding to a form with r + n arguments, that is, a
/// mapping
///
///     a : V1 x V2 x ... Vr x W1 x W2 x ... x Wn -> R
///
/// with arguments v1, v2, ..., vr, w1, w2, ..., wn. The rank r
/// global tensor A is defined by
///
///     A = a(V1, V2, ..., Vr, w1, w2, ..., wn),
///
/// where each argument Vj represents the application to the
/// sequence of basis functions of Vj and w1, w2, ..., wn are given
/// fixed functions (coefficients).

class UFC_LPTcdgILinearForm: public ufc::form
{
public:

  /// Constructor
  UFC_LPTcdgILinearForm() : ufc::form()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_LPTcdgILinearForm()
  {
    // Do nothing
  }

  /// Return a string identifying the form
  virtual const char* signature() const
  {
    return "Form([Integral(Sum(Product(Indexed(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((FixedIndex(1),))), Product(FloatValue(-0.5, (), (), {}), IndexSum(Product(Indexed(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(0),))), MultiIndex((Index(0),))), MultiIndex((Index(1),))), Indexed(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(2),))), MultiIndex((Index(2),))), MultiIndex((Index(1),)))), MultiIndex((Index(1),))))), Sum(Product(Indexed(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((FixedIndex(1),))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 1), Product(IntValue(-1, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 3)))), Sum(Product(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(3),))), MultiIndex((Index(4),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(4),))), MultiIndex((Index(3),))), MultiIndex((Index(3),))), Product(IndexSum(Indexed(ComponentTensor(SpatialDerivative(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(5),))), MultiIndex((Index(6),))), MultiIndex((Index(6),))), MultiIndex((Index(5),))), MultiIndex((Index(5),))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(FloatValue(0.083333333333333426, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0)))))), Product(IndexSum(Product(Indexed(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(7),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(7),))), MultiIndex((Index(8),))), Indexed(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(9),))), MultiIndex((Index(9),))), MultiIndex((Index(8),)))), MultiIndex((Index(8),))), Sum(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 1)))))), Measure('cell', 0, {'ffc_representation': 'quadrature', 'quadrature_order': 4})), Integral(Sum(Product(Division(PositiveRestricted(Constant(Cell('triangle', 1), 5)), PositiveRestricted(Constant(Cell('triangle', 1), 6))), Product(Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(10),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(10),)))), MultiIndex((Index(11),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(11),)))), MultiIndex((Index(11),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(12),))), MultiIndex((FixedIndex(1),))), MultiIndex((Index(12),)))), MultiIndex((Index(13),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(13),)))), MultiIndex((Index(13),)))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(14),))), MultiIndex((Index(14),)))), MultiIndex((Index(15),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(15),)))), MultiIndex((Index(15),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(16),))), MultiIndex((Index(16),)))), MultiIndex((Index(17),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(17),)))), MultiIndex((Index(17),)))))), Sum(Product(Division(PositiveRestricted(Constant(Cell('triangle', 1), 5)), PositiveRestricted(Constant(Cell('triangle', 1), 6))), Product(Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(18),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(18),)))), MultiIndex((Index(19),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(19),)))), MultiIndex((Index(19),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(20),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(20),)))), MultiIndex((Index(21),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(21),)))), MultiIndex((Index(21),)))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 1), MultiIndex((Index(22),))), MultiIndex((Index(22),)))), MultiIndex((Index(23),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(23),)))), MultiIndex((Index(23),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 1), MultiIndex((Index(24),))), MultiIndex((Index(24),)))), MultiIndex((Index(25),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(25),)))), MultiIndex((Index(25),)))))), Sum(Product(Product(Product(FloatValue(0.5, (), (), {}), Sum(NegativeRestricted(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(26),))), MultiIndex((Index(27),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(27),))), MultiIndex((Index(26),))), MultiIndex((Index(26),)))), PositiveRestricted(IndexSum(Indexed(ComponentTensor(Indexed(SpatialDerivative(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(28),))), MultiIndex((Index(29),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(29),))), MultiIndex((Index(28),))), MultiIndex((Index(28),)))))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(FloatValue(-0.083333333333333426, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0))))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(30),))), MultiIndex((Index(30),)))), MultiIndex((Index(31),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(31),)))), MultiIndex((Index(31),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(32),))), MultiIndex((Index(32),)))), MultiIndex((Index(33),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(33),)))), MultiIndex((Index(33),))))), Product(Product(Product(FloatValue(0.5, (), (), {}), Sum(NegativeRestricted(IndexSum(Indexed(ComponentTensor(SpatialDerivative(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(34),))), MultiIndex((Index(35),))), MultiIndex((Index(35),))), MultiIndex((Index(34),))), MultiIndex((Index(34),)))), PositiveRestricted(IndexSum(Indexed(ComponentTensor(SpatialDerivative(SpatialDerivative(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 2), MultiIndex((Index(36),))), MultiIndex((Index(37),))), MultiIndex((Index(37),))), MultiIndex((Index(36),))), MultiIndex((Index(36),)))))), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0), Product(FloatValue(-0.083333333333333426, (), (), {}), Function(FiniteElement('Lagrange', Cell('triangle', 1), 2), 0))))), Sum(IndexSum(Product(Indexed(NegativeRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(38),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(38),)))), MultiIndex((Index(39),))), Indexed(NegativeRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(39),)))), MultiIndex((Index(39),))), IndexSum(Product(Indexed(PositiveRestricted(ComponentTensor(Indexed(SpatialDerivative(BasisFunction(MixedElement(*[FiniteElement('Lagrange', Cell('triangle', 1), 2), FiniteElement('Lagrange', Cell('triangle', 1), 2)], **{'value_shape': (2,) }), 0), MultiIndex((Index(40),))), MultiIndex((FixedIndex(0),))), MultiIndex((Index(40),)))), MultiIndex((Index(41),))), Indexed(PositiveRestricted(VectorConstant(Cell('triangle', 1), 2, 4)), MultiIndex((Index(41),)))), MultiIndex((Index(41),)))))))), Measure('interior_facet', 0, {'ffc_representation': 'quadrature', 'quadrature_order': 4}))])";
  }

  /// Return the rank of the global tensor (r)
  virtual unsigned int rank() const
  {
    return 1;
  }

  /// Return the number of coefficients (n)
  virtual unsigned int num_coefficients() const
  {
    return 7;
  }

  /// Return the number of cell integrals
  virtual unsigned int num_cell_integrals() const
  {
    return 1;
  }
  
  /// Return the number of exterior facet integrals
  virtual unsigned int num_exterior_facet_integrals() const
  {
    return 0;
  }
  
  /// Return the number of interior facet integrals
  virtual unsigned int num_interior_facet_integrals() const
  {
    return 1;
  }
    
  /// Create a new finite element for argument function i
  virtual ufc::finite_element* create_finite_element(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgILinearForm_finite_element_0();
      break;
    case 1:
      return new UFC_LPTcdgILinearForm_finite_element_1();
      break;
    case 2:
      return new UFC_LPTcdgILinearForm_finite_element_2();
      break;
    case 3:
      return new UFC_LPTcdgILinearForm_finite_element_3();
      break;
    case 4:
      return new UFC_LPTcdgILinearForm_finite_element_4();
      break;
    case 5:
      return new UFC_LPTcdgILinearForm_finite_element_5();
      break;
    case 6:
      return new UFC_LPTcdgILinearForm_finite_element_6();
      break;
    case 7:
      return new UFC_LPTcdgILinearForm_finite_element_7();
      break;
    }
    return 0;
  }
  
  /// Create a new dof map for argument function i
  virtual ufc::dof_map* create_dof_map(unsigned int i) const
  {
    switch (i)
    {
    case 0:
      return new UFC_LPTcdgILinearForm_dof_map_0();
      break;
    case 1:
      return new UFC_LPTcdgILinearForm_dof_map_1();
      break;
    case 2:
      return new UFC_LPTcdgILinearForm_dof_map_2();
      break;
    case 3:
      return new UFC_LPTcdgILinearForm_dof_map_3();
      break;
    case 4:
      return new UFC_LPTcdgILinearForm_dof_map_4();
      break;
    case 5:
      return new UFC_LPTcdgILinearForm_dof_map_5();
      break;
    case 6:
      return new UFC_LPTcdgILinearForm_dof_map_6();
      break;
    case 7:
      return new UFC_LPTcdgILinearForm_dof_map_7();
      break;
    }
    return 0;
  }

  /// Create a new cell integral on sub domain i
  virtual ufc::cell_integral* create_cell_integral(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_cell_integral_0();
  }

  /// Create a new exterior facet integral on sub domain i
  virtual ufc::exterior_facet_integral* create_exterior_facet_integral(unsigned int i) const
  {
    return 0;
  }

  /// Create a new interior facet integral on sub domain i
  virtual ufc::interior_facet_integral* create_interior_facet_integral(unsigned int i) const
  {
    return new UFC_LPTcdgILinearForm_interior_facet_integral_0();
  }

};

// DOLFIN wrappers

#include <dolfin/fem/Form.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/function/Coefficient.h>
#include <dolfin/function/Function.h>
#include <dolfin/function/FunctionSpace.h>

class LPTcdgIBilinearFormFunctionSpace0 : public dolfin::FunctionSpace
{
public:

  LPTcdgIBilinearFormFunctionSpace0(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_0()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_0()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgIBilinearFormFunctionSpace1 : public dolfin::FunctionSpace
{
public:

  LPTcdgIBilinearFormFunctionSpace1(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_0()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_0()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgIBilinearFormCoefficientSpace0 : public dolfin::FunctionSpace
{
public:

  LPTcdgIBilinearFormCoefficientSpace0(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_4()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_4()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgIBilinearFormCoefficientSpace1 : public dolfin::FunctionSpace
{
public:

  LPTcdgIBilinearFormCoefficientSpace1(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_5()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_5()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgIBilinearFormCoefficientSpace2 : public dolfin::FunctionSpace
{
public:

  LPTcdgIBilinearFormCoefficientSpace2(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_7()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_7()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgIBilinearFormCoefficientSpace3 : public dolfin::FunctionSpace
{
public:

  LPTcdgIBilinearFormCoefficientSpace3(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_7()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_7()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormFunctionSpace0 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormFunctionSpace0(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_0()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_0()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormCoefficientSpace0 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormCoefficientSpace0(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_4()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_4()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormCoefficientSpace1 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormCoefficientSpace1(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_4()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_4()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormCoefficientSpace2 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormCoefficientSpace2(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_4()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_4()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormCoefficientSpace3 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormCoefficientSpace3(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_4()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_4()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormCoefficientSpace4 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormCoefficientSpace4(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_5()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_5()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormCoefficientSpace5 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormCoefficientSpace5(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_7()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_7()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgILinearFormCoefficientSpace6 : public dolfin::FunctionSpace
{
public:

  LPTcdgILinearFormCoefficientSpace6(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_7()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_7()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgITestSpace : public dolfin::FunctionSpace
{
public:

  LPTcdgITestSpace(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_0()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_0()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgITrialSpace : public dolfin::FunctionSpace
{
public:

  LPTcdgITrialSpace(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_0()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_0()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgIFunctionSpace : public dolfin::FunctionSpace
{
public:

  LPTcdgIFunctionSpace(const dolfin::Mesh& mesh)
    : dolfin::FunctionSpace(boost::shared_ptr<const dolfin::Mesh>(&mesh, dolfin::NoDeleter<const dolfin::Mesh>()),
                            boost::shared_ptr<const dolfin::FiniteElement>(new dolfin::FiniteElement(boost::shared_ptr<ufc::finite_element>(new UFC_LPTcdgILinearForm_finite_element_0()))),
                            boost::shared_ptr<const dolfin::DofMap>(new dolfin::DofMap(boost::shared_ptr<ufc::dof_map>(new UFC_LPTcdgILinearForm_dof_map_0()), mesh)))
  {
    // Do nothing
  }

};

class LPTcdgIBilinearFormCoefficient0 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgIBilinearFormCoefficient0(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgIBilinearFormCoefficient0() {}

  // Attach function to coefficient
  const LPTcdgIBilinearFormCoefficient0& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgIBilinearFormCoefficientSpace0(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 0;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "h";
  }
  
};
class LPTcdgIBilinearFormCoefficient1 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgIBilinearFormCoefficient1(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgIBilinearFormCoefficient1() {}

  // Attach function to coefficient
  const LPTcdgIBilinearFormCoefficient1& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgIBilinearFormCoefficientSpace1(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 1;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "n";
  }
  
};
class LPTcdgIBilinearFormCoefficient2 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgIBilinearFormCoefficient2(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgIBilinearFormCoefficient2() {}

  // Attach function to coefficient
  const LPTcdgIBilinearFormCoefficient2& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgIBilinearFormCoefficientSpace2(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 2;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "tau";
  }
  
};
class LPTcdgIBilinearFormCoefficient3 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgIBilinearFormCoefficient3(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgIBilinearFormCoefficient3() {}

  // Attach function to coefficient
  const LPTcdgIBilinearFormCoefficient3& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgIBilinearFormCoefficientSpace3(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 3;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "e";
  }
  
};
class LPTcdgIBilinearForm : public dolfin::Form
{
public:

  // Create form on given function space(s)
  LPTcdgIBilinearForm(const dolfin::FunctionSpace& V0, const dolfin::FunctionSpace& V1) : dolfin::Form(), h(*this), n(*this), tau(*this), e(*this)
  {
    boost::shared_ptr<const dolfin::FunctionSpace> _V0(&V0, dolfin::NoDeleter<const dolfin::FunctionSpace>());
    _function_spaces.push_back(_V0);
    boost::shared_ptr<const dolfin::FunctionSpace> _V1(&V1, dolfin::NoDeleter<const dolfin::FunctionSpace>());
    _function_spaces.push_back(_V1);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgIBilinearForm());
  }

  // Create form on given function space(s) (shared data)
  LPTcdgIBilinearForm(boost::shared_ptr<const dolfin::FunctionSpace> V0, boost::shared_ptr<const dolfin::FunctionSpace> V1) : dolfin::Form(), h(*this), n(*this), tau(*this), e(*this)
  {
    _function_spaces.push_back(V0);
    _function_spaces.push_back(V1);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgIBilinearForm());
  }

  // Create form on given function space(s) with given coefficient(s)
  LPTcdgIBilinearForm(const dolfin::FunctionSpace& V0, const dolfin::FunctionSpace& V1, dolfin::Function& w0, dolfin::Function& w1, dolfin::Function& w2, dolfin::Function& w3) : dolfin::Form(), h(*this), n(*this), tau(*this), e(*this)
  {
    boost::shared_ptr<const dolfin::FunctionSpace> _V0(&V0, dolfin::NoDeleter<const dolfin::FunctionSpace>());
    _function_spaces.push_back(_V0);
    boost::shared_ptr<const dolfin::FunctionSpace> _V1(&V1, dolfin::NoDeleter<const dolfin::FunctionSpace>());
    _function_spaces.push_back(_V1);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    this->h = w0;
    this->n = w1;
    this->tau = w2;
    this->e = w3;

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgIBilinearForm());
  }

  // Create form on given function space(s) with given coefficient(s) (shared data)
  LPTcdgIBilinearForm(boost::shared_ptr<const dolfin::FunctionSpace> V0, boost::shared_ptr<const dolfin::FunctionSpace> V1, dolfin::Function& w0, dolfin::Function& w1, dolfin::Function& w2, dolfin::Function& w3) : dolfin::Form(), h(*this), n(*this), tau(*this), e(*this)
  {
    _function_spaces.push_back(V0);
    _function_spaces.push_back(V1);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    this->h = w0;
    this->n = w1;
    this->tau = w2;
    this->e = w3;

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgIBilinearForm());
  }

  // Destructor
  ~LPTcdgIBilinearForm() {}

  // Coefficients
  LPTcdgIBilinearFormCoefficient0 h;
  LPTcdgIBilinearFormCoefficient1 n;
  LPTcdgIBilinearFormCoefficient2 tau;
  LPTcdgIBilinearFormCoefficient3 e;

};

class LPTcdgILinearFormCoefficient0 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgILinearFormCoefficient0(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgILinearFormCoefficient0() {}

  // Attach function to coefficient
  const LPTcdgILinearFormCoefficient0& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgILinearFormCoefficientSpace0(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 0;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "h";
  }
  
};
class LPTcdgILinearFormCoefficient1 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgILinearFormCoefficient1(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgILinearFormCoefficient1() {}

  // Attach function to coefficient
  const LPTcdgILinearFormCoefficient1& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgILinearFormCoefficientSpace1(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 1;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "eta0";
  }
  
};
class LPTcdgILinearFormCoefficient2 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgILinearFormCoefficient2(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgILinearFormCoefficient2() {}

  // Attach function to coefficient
  const LPTcdgILinearFormCoefficient2& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgILinearFormCoefficientSpace2(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 2;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "phi0";
  }
  
};
class LPTcdgILinearFormCoefficient3 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgILinearFormCoefficient3(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgILinearFormCoefficient3() {}

  // Attach function to coefficient
  const LPTcdgILinearFormCoefficient3& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgILinearFormCoefficientSpace3(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 3;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "g";
  }
  
};
class LPTcdgILinearFormCoefficient4 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgILinearFormCoefficient4(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgILinearFormCoefficient4() {}

  // Attach function to coefficient
  const LPTcdgILinearFormCoefficient4& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgILinearFormCoefficientSpace4(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 4;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "n";
  }
  
};
class LPTcdgILinearFormCoefficient5 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgILinearFormCoefficient5(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgILinearFormCoefficient5() {}

  // Attach function to coefficient
  const LPTcdgILinearFormCoefficient5& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgILinearFormCoefficientSpace5(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 5;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "tau";
  }
  
};
class LPTcdgILinearFormCoefficient6 : public dolfin::Coefficient
{
public:

  // Constructor
  LPTcdgILinearFormCoefficient6(dolfin::Form& form) : dolfin::Coefficient(form) {}

  // Destructor  
  ~LPTcdgILinearFormCoefficient6() {}

  // Attach function to coefficient
  const LPTcdgILinearFormCoefficient6& operator= (dolfin::Function& v)
  {
    attach(v);
    return *this;
  }

  /// Create function space for coefficient
  const dolfin::FunctionSpace* create_function_space() const
  {
    return new LPTcdgILinearFormCoefficientSpace6(form.mesh());
  }
  
  /// Return coefficient number
  dolfin::uint number() const
  {
    return 6;
  }
  
  /// Return coefficient name
  virtual std::string name() const
  {
    return "e";
  }
  
};
class LPTcdgILinearForm : public dolfin::Form
{
public:

  // Create form on given function space(s)
  LPTcdgILinearForm(const dolfin::FunctionSpace& V0) : dolfin::Form(), h(*this), eta0(*this), phi0(*this), g(*this), n(*this), tau(*this), e(*this)
  {
    boost::shared_ptr<const dolfin::FunctionSpace> _V0(&V0, dolfin::NoDeleter<const dolfin::FunctionSpace>());
    _function_spaces.push_back(_V0);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgILinearForm());
  }

  // Create form on given function space(s) (shared data)
  LPTcdgILinearForm(boost::shared_ptr<const dolfin::FunctionSpace> V0) : dolfin::Form(), h(*this), eta0(*this), phi0(*this), g(*this), n(*this), tau(*this), e(*this)
  {
    _function_spaces.push_back(V0);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgILinearForm());
  }

  // Create form on given function space(s) with given coefficient(s)
  LPTcdgILinearForm(const dolfin::FunctionSpace& V0, dolfin::Function& w0, dolfin::Function& w1, dolfin::Function& w2, dolfin::Function& w3, dolfin::Function& w4, dolfin::Function& w5, dolfin::Function& w6) : dolfin::Form(), h(*this), eta0(*this), phi0(*this), g(*this), n(*this), tau(*this), e(*this)
  {
    boost::shared_ptr<const dolfin::FunctionSpace> _V0(&V0, dolfin::NoDeleter<const dolfin::FunctionSpace>());
    _function_spaces.push_back(_V0);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    this->h = w0;
    this->eta0 = w1;
    this->phi0 = w2;
    this->g = w3;
    this->n = w4;
    this->tau = w5;
    this->e = w6;

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgILinearForm());
  }

  // Create form on given function space(s) with given coefficient(s) (shared data)
  LPTcdgILinearForm(boost::shared_ptr<const dolfin::FunctionSpace> V0, dolfin::Function& w0, dolfin::Function& w1, dolfin::Function& w2, dolfin::Function& w3, dolfin::Function& w4, dolfin::Function& w5, dolfin::Function& w6) : dolfin::Form(), h(*this), eta0(*this), phi0(*this), g(*this), n(*this), tau(*this), e(*this)
  {
    _function_spaces.push_back(V0);

    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));
    _coefficients.push_back(boost::shared_ptr<const dolfin::Function>(static_cast<const dolfin::Function*>(0)));

    this->h = w0;
    this->eta0 = w1;
    this->phi0 = w2;
    this->g = w3;
    this->n = w4;
    this->tau = w5;
    this->e = w6;

    _ufc_form = boost::shared_ptr<const ufc::form>(new UFC_LPTcdgILinearForm());
  }

  // Destructor
  ~LPTcdgILinearForm() {}

  // Coefficients
  LPTcdgILinearFormCoefficient0 h;
  LPTcdgILinearFormCoefficient1 eta0;
  LPTcdgILinearFormCoefficient2 phi0;
  LPTcdgILinearFormCoefficient3 g;
  LPTcdgILinearFormCoefficient4 n;
  LPTcdgILinearFormCoefficient5 tau;
  LPTcdgILinearFormCoefficient6 e;

};

#endif
